####################################
 ### jIRCoff Fserve tcl - DVS01 ###
 ### For Eggdrop1.6.x           ###
 ### Started 7-4-99             ###
####################################

# DVS01@EFnet&Undernet, dvs01@mindspring.com

### CONFIG INIT ###
proc dvs_func:config-init {} {
	global dvs_fserve dvs_max_nickchars dvs_max_identchars dvs_fserve_floodratio env
	
	if {[info procs dvs_fserve:func:traceinit] == "dvs_fserve:func:traceinit"} then {
		dvs_fserve:func:traceinit 1
	}

	set tryloading 1
	set waserr 0
	set configfile ./jIRCserv.[dvs_fserve:func:version version formatted].cfg
	if {![file exists $configfile] || ![file isfile $configfile]} then {
		putlog "j[u][b]IRC[b]off[u] Fserve: Config file not found.  Loading defaults."
		set tryloading 0
	}
	if {$tryloading && [catch {source $configfile} err]} then {
		set waserr 1
		putlog "j[u][b]IRC[b]off[u] Fserve: Error(s) loading config file."
		putlog $err
	}
		
	# Default configuration settings
	set dvs_fserve(enable) 1
	set dvs_fserve(validuser) 0
	set dvs_fserve(triggers) {
		{"!fs" pub o|o 1}
		{"!fs" msg -|- 0}
		{"FS" ctcp -|- 0}
	}
	set dvs_fserve(stupidusers) 1
	set dvs_fserve(content) "jIRCoff Fserve"
	set dvs_fserve(ad_while_off) 0
	set dvs_fserve(channels) {
		{* 5}
	}
	set dvs_fserve(bans) {
		lamer!lameone@lame.isp.net
		*!*@*.aol.sucks
	}
	set dvs_fserve(ad) 1
	set dvs_fserve(onjoin) 0
	set dvs_fserve(admode) 1
	set dvs_fserve(ad_linemin) 40
	set dvs_fserve(msg_to_notonchan) 0
	set dvs_fserve(maxmatches) 30
	set dvs_fserve(motd) "./jIRCserv/motd.txt"
	set dvs_fserve(datafile) "./jIRCserv/jIRCserv.dat"
	set dvs_fserve(filepath) $env(HOME)/eggdrop/fserve
	set dvs_fserve(janflags) jJ
	set dvs_fserve(jdirs) {
		$env(HOME)/eggdrop/fserve/incoming
		$env(HOME)/eggdrop/fserve/priv
	}
	set dvs_fserve(filefilter) {
		{* $env(HOME)/eggdrop/fserve/incoming 1}
		{*.txt $env(HOME)/eggdrop/fserve/txts 1}
	}
	set dvs_fserve(ratiotype) 0
	set dvs_fserve(bratio) 1:4
	set dvs_fserve(fratio) 1:4
	set dvs_fserve(startbcredits) 15000
	set dvs_fserve(startfcredits) 3
	set dvs_fserve_floodratio(onjoin) 4:7
	set dvs_fserve_floodratio(pub) 5:5
	set dvs_fserve_floodratio(fserve) 7:7
	set dvs_fserve(maxdloads) 3
	set dvs_fserve(maxqdloads) 10
	set dvs_fserve(maxuploads) 3
	set dvs_fserve(maxtrans) 4
	set dvs_fserve(maxsends) 10
	set dvs_fserve(maxgets) 5
	set dvs_fserve(maxslots) 6
	set dvs_fserve(renspace) 1
	set dvs_fserve(allowuploads) 1
	set dvs_fserve(expireuser) 30
	set dvs_fserve(maxclone) 1
	set dvs_fserve(maxidle) 200
	set dvs_fserve(maxchars) 80
	set dvs_fserve(globget) 1
	set dvs_fserve(globcd) 1
	set dvs_max_nickchars 9
	set dvs_max_identchars 10
	set dvs_fserve(maxsends) 10
	
	if {!$tryloading && ![info exists dvs_fserve(default_first)] || !$dvs_fserve(default_first)} then {
		return
	} else {
		if {[catch {source $configfile} err] && !$waserr} then {
			putlog "j[u][b]IRC[b]off[u] Fserve: Error(s) loading config file:"
			putlog $err
		}
	}
	return
}

### VERSION ###
set dvs_fserve_version 0x02
set dvs_fserve_vts "Thu Jul 06 01:18:01 EST 2000"

### FSERVE STARTUP ###
proc dvs_fserve:func:startup {} {
	global dvs_fserve dvs_fserve_slots dvs_fserve_path dvs_fserve_pwd
	
	if {![info exists dvs_fserve_slots(pending)]} then {
		set dvs_fserve_slots(pending) ""
	}

	bind evnt - prerehash dvs_fserve:evnt:save
	
	dvs_func:config-init
	
	dvs_fserve:func:stats-init

	dvs_fserve:func:binds
	
	dvs_func:tracecall dvs_fserve filepath -
	dvs_fserve:func:traceinit

	dvs_fserve:ad-init

	dvs_fserve:func:du
	
	bind dcc $dvs_fserve(janflags) jserv dvs_fserve:dcc:jserv
	
	if {[file exists $dvs_fserve(datafile)] && [file size $dvs_fserve(datafile)] > 0} then {
		dvs_fserve:func:loadsettings 1
		dvs_fserve:func:savesettings 1
	} else {
		dvs_fserve:func:savesettings 1
	}

	if {![string match -nocase *dvs?fserve?func?floodctrl* [utimers]]} then {
		utimer 5 "dvs_fserve:func:floodctrl clean"
	}
	if {![string match -nocase *dvs?fserve?func?usercleanup* [utimers]]} then {
		utimer 10 dvs_fserve:func:usercleanup
	}
	if {![string match -nocase *dvs?fserve?func?pendclean* [utimers]]} then {
		utimer 15 dvs_fserve:func:pendclean
	}
	if {![string match -nocase *dvs?fserve?func?pendcheck* [utimers]]} then {
		utimer 20 dvs_fserve:func:pendcheck
	}
	if {![string match -nocase *dvs?fserve?func?linecount-clean* [utimers]]} then {
		utimer 20 dvs_fserve:func:linecount-clean
	}
}

### PREREHASH SAVING ###
proc dvs_fserve:evnt:save {type} {
	dvs_fserve:func:savesettings 1
}

### SETTINGS INFO ###
proc dvs_fserve:func:settings-info {cmd {element ""}} {
	set elements {
		{uses %d}
		{koffered %f}
		{foffered %d}
		{ksnagged %f}
		{fsnagged %d}
		{krecieved %f}
		{frecieved %d}
	}
	
	switch -- $cmd\
	elements {
		return $elements
	} isvalid {
		return [expr ([lsearch -glob [dvs_fserve:func:settings-info elements] "$element *"] == -1) ? 0 : 1]
	}
}
		

### LOADING SETTINGS ###
proc dvs_fserve:func:loadsettings {{quiet 0}} {
	global dvs_fserve dvs_fserve_stats
	
	if {![file exists $dvs_fserve(datafile)] || ![file isfile $dvs_fserve(datafile)]} then {
		return
	}
	set fileid [open $dvs_fserve(datafile) r]

	if {!$quiet} then {
		putlog "j[u][b]IRC[b]off[u] Fserve: Loading settings file."
	}

	while {![eof $fileid]} {
		gets $fileid line
		if {[scan $line "%s %s" keyword value] == -1} then {
			continue
		}
		if {![dvs_fserve:func:settings-info isvalid $keyword]} then {
			continue
		}
		set dvs_fserve_stats($keyword) $value
	}
	close $fileid
}

### SAVING SETTINGS ###
proc dvs_fserve:func:savesettings {{quiet 0}} {
	global dvs_fserve dvs_fserve_stats
	
	if {!$quiet} then {
		putlog "j[u][b]IRC[b]off[u] Fserve: Saving settings file."
	}
	
	set path [file dirname $dvs_fserve(datafile)]
	set filename [file tail $dvs_fserve(datafile)]
	if {![file exists $path]} then {
		catch {
			file mkdir $path
		}
	}
	if {[catch {set fileid [open $dvs_fserve(datafile) w]}]} then {
		putlog "j[u][b]IRC[b]off[u] Fserve: Couldn't write to $dvs_fserve(datafile)"
	}
	foreach entry [dvs_fserve:func:settings-info elements] {
		set element [lindex $entry 0]
		set format [lindex $entry 1]
		scan $dvs_fserve_stats($element) $format value
		puts $fileid "$element $value"
	}
	close $fileid

	if {![string match -nocase *dvs?fserve?func?savesettings* [timers]]} then {
		timer 50 dvs_fserve:func:savesettings
	}

	return
}

### VALID NUM CHECK ###
proc dvs_func:validnum {num} {
	catch {
		set result [expr $num * 0]
	} result
	#global errorInfo
	#putlog $errorInfo
	if {$result != 0} then {
		return 0
	} else {
		return 1
	}
}

### NULL VALUES ###
proc dvs_func:null {format} {
	switch -- $format\
	%d - %o - %x - %X - %u - %i {
		return 0
	} %c - %s {
		return ""
	} %e - %E - %f - %g - %G {
		return 0.0
	} default {
		return 0
	}
}

### mIRC CONTROL CHARS ###
proc b {} {
	return 
}
proc k {} {
	return 
}
proc o {} {
	return 
}
proc r {} {
	return 
}
proc u {} {
	return 
}

#### Eggdrop version test ###
if {$numversion < 1032900} then {
	putlog "j[u][b]IRC[b]off[u] Fserve warning: Eggdrop version must be at least 1.3.29 for the Fserve to work properly"
}

### VARIABLE TRACE INITIALIZATION ###
proc dvs_fserve:func:traceinit {{killonly "0"}} {
	global dvs_fserve
	foreach var {
		dvs_fserve(triggers)
		dvs_fserve(filepath)
		dvs_fserve(enable)
		dvs_fserve(channels)
		dvs_fserve(janflags)
	} {
		dvs_func:tracedel $var
		if {!$killonly} then {
			trace variable $var w dvs_func:tracecall
		}
	}
	return
}

proc dvs_func:tracecall {var index mode} {
	switch -- $var\
	dvs_fserve {
		switch -- $index\
		triggers {
			dvs_fserve:func:binds
		} bind {
			dvs_fserve:func:binds
		} enable {
			global dvs_fserve dvs_fserve_stats
			set dvs_fserve_stats(reenable) [expr ($dvs_fserve_stats(reenable) == 2) ? 1 : 0]
			if {!$dvs_fserve(enable) && $dvs_fserve_stats(wasenabled)} then {
				putlog "j[u][b]IRC[b]off[u] Fserve: Disabled."
			} elseif {$dvs_fserve(enable) && !$dvs_fserve_stats(wasenabled)} then {
				putlog "j[u][b]IRC[b]off[u] Fserve: Enabled."
			}
			set dvs_fserve_stats(wasenabled) $dvs_fserve(enable)
		} filepath {
			global dvs_fserve dvs_fserve_stats
			if {![dvs_fserve:func:dir isvalid -]} then {
				putlog "j[u][b]IRC[b]off[u] Fserve error: Invalid Fserve path."
				set dvs_fserve_stats(reenable) 2
				set dvs_fserve(enable) 0
				set dvs_fserve_stats(lock) 1
			} elseif {$dvs_fserve_stats(reenable)} then {
				set dvs_fserve(enable) 1
				set dvs_fserve_stats(lock) 0
			} else {
				set dvs_fserve_stats(lock) 0
			}
		} channels - ad_linemin {
			dvs_fserve:ad-init
		} janflags {
			global dvs_fserve
			bind dcc $dvs_fserve(janflags) jserv dvs_fserve:dcc:jserv
		} default {
			return
		}
	} default {
		return
	}
}
proc dvs_func:tracedel {var} {
	global dvs_fserve
	foreach element [trace vinfo $var] {
		uplevel 0 trace vdelete $var [lindex $element 0] [lindex $element 1]
	}
	return
}

### VERSION MANIPULATION ###
proc dvs_fserve:func:version {element {format ""}} {
	global dvs_fserve_version dvs_fserve_vts
	set ts [clock scan $dvs_fserve_vts]
	switch -- $element\
	version {
		switch -- $format\
		long {
			return [format %u $dvs_fserve_version]
		} hex {
			return $dvs_fserve_version
		} 0long {
			return [format %05u $dvs_fserve_version]
		} formatted {
			return [format %.2f [expr $dvs_fserve_version * .01]]
		} default {
			return -1
		}
	} ts {
		switch -- $element\
		datetime {
			return [strftime "%m-%d-%y %H:%M:%S" $ts]
		} date {
			return [strftime "%m-%d-%y" $ts]
		} strdate {
			return [strftime "%b %d, %Y" $ts]
		} strdatetime {
			return [strftime "%b %d, %Y %H:%M:%S" $ts]
		} default {
			return [strftime "%m-%d-%y" $ts]
		}
	} default {
		return -1
	}
}

### LOGGING ###
# dvs_fserve:log:
#  cmd input chatter outgoing incoming

proc dvs_fserve:log:cmd {text} {
	putloglev 4 commands $text
}
proc dvs_fserve:log:input {text} {
	putloglev 4 input $text
}
proc dvs_fserve:log:chatter {text} {
	putloglev 4 chatter $text
}
proc dvs_fserve:log:outgoing {text} {
	putloglev 4 outgoing $text
}
proc dvs_fserve:log:incoming {text} {
	putloglev 4 incoming $text
}


### FREE SLOT COUNTER ###
proc dvs_fserve:func:slotcount {} {
	global dvs_fserve dvs_fserve_availslots dvs_fserve_slots
	
	set count [expr [array size dvs_fserve_slots] - 1 + [llength $dvs_fserve_slots(pending)]]
	set dvs_fserve_availslots [expr ($count > $dvs_fserve(maxslots)) ? 0 : $dvs_fserve(maxslots) - $count]
	return $dvs_fserve_availslots
}

### AD GENERATOR ###
# keyword type bind
# !fs     pub  o|o
proc dvs_fserve:func:adgen {} {
	global dvs_fserve botnick
	if {$dvs_fserve(enable)} then {
		set enable on
	} else {
		set enable off
	}
	if {[llength $dvs_fserve(triggers)] > 1} then {
		set triggers "Triggers: "
	} else {
		set triggers "Trigger: "
	}
	set pubcount 0
	set msgcount 0
	set ctcpcount 0
	set publist ""
	set msglist ""
	set ctcplist ""
	
	if {$dvs_fserve(stupidusers)} then {
		set pubtype "[u]Say[u][b]:[b]"
		set msgtype "[b]/msg[b] [u]${botnick}[u][b]:[b]"
		set ctcptype "[b]/ctcp[b] [u]${botnick}[u][b]:[b]"
	} else {
		set pubtype "[u]pub[u][b]:[b]"
		set msgtype "[u]msg[u][b]:[b]"
		set ctcptype "[u]ctcp[u][b]:[b]"
	}
	
	foreach trigger $dvs_fserve(triggers) {
		set keyword [lindex $trigger 0]
		set type    [lindex $trigger 1]
		set hide    [lindex $trigger 3]
		if {$hide} then {
			continue
		}
		if {[subst $${type}count] > 0} then {
			append ${type}list ", $keyword"
		} else {
			append ${type}list " ..[subst $${type}type] $keyword"
		}
		incr ${type}count
	}
	switch -- $dvs_fserve(ratiotype)\
	0 {
		set ratio "No ratio"
	} 1 {
		set ratio "Byte ratio $dvs_fserve(bratio), [expr int($dvs_fserve(startbcredits))] initial credits"
	} 2 {
		set ratio "File ratio $dvs_fserve(fratio), [expr int($dvs_fserve(startfcredits))] initial credits"
	} 3 {
		set ratio "Byte ratio $dvs_fserve(bratio) with [expr int($dvs_fserve(startbcredits))] byte credits, file ratio $dvs_fserve(fratio) with [expr int($dvs_fserve(startfcredits))] file credits"
	}
	set slots "[dvs_fserve:func:slotcount]/$dvs_fserve(maxslots) open slots"
	return "j[u][b]IRC[b]off[u] Fserve is $enable. [dvs_func:plural [llength [split ${publist}${msglist}${ctcplist}]] Trigger Triggers]:${publist}${msglist}${ctcplist}. $ratio. $slots. Content: $dvs_fserve(content)"
}

### MOTD DISPLAYER ###
proc dvs_fserve:func:motd {{idx ""}} {
	global dvs_fserve dvs_fserve_slots
	
	if {![info exists dvs_fserve_slots($idx)]} then {
		return "Invalid idx"
	}
	
	if {![file exists $dvs_fserve(motd)]} then {
		return
	}
	set infile [open $dvs_fserve(motd)]
	set temp [unixtime]![clock clicks]
	while {![eof $infile]} {
		gets $infile line
		if {![info exists cidx]} then {
			set cidx 0
		}
		while {[string first % $line] != -1} {
			
			set idx1 [string first % $line $cidx]
			if {[string is space -strict [string index $line [expr $idx1 + 1]]]} then {
				set idx2 [string wordend $line $idx1]
			} else {
				set idx2 [string wordend $line [expr $idx1 + 1]]
			}
			set cidx $idx2
			
			if {$idx1 == -1} then {
				continue
			}
			set backsp 0
			switch -- [string range $line [expr $idx1 + 1] [expr $idx2 - 1]]\
			botnick {
				global botnick
				set replacement $botnick
			} nick {
				set replacement [dvs_fserve:func:slots get $idx nick]
			} uhost {
				set replacement [dvs_fserve:func:slots get $idx uhost]
			} version {
				set replacement [dvs_fserve:func:version version formatted]
			} vdate {
				global dvs_fserve_vdate
				set replacement $dvs_fserve_vdate
			} % {
				set replacement ${temp}!percent
			} freeslots {
				set replacement [dvs_fserve:func:slotcount]
			} totalslots {
				set replacement $dvs_fserve(maxslots)
			} usedslots {
				set replacement [expr [llength [array names dvs_fserve_slots]] -1]
			} ratiocred {
				set bcredits [expr int([dvs_fserve:func:slots get $idx bcredits])]
				set fcredits [expr int([dvs_fserve:func:slots get $idx fcredits])]
				switch -- $dvs_fserve(ratiotype)\
				0 {
					set replacement "No ratio"
				} 1 {
					set replacement "Byte ratio $dvs_fserve(bratio), $bcredits [dvs_func:plural $bcredits credit credits]"
				} 2 {
					set replacement "File ratio $dvs_fserve(fratio), $fcredits [dvs_func:plural $fcredits credit credits]"
				} 3 {
					set replacement "Byte ratio $dvs_fserve(bratio) with $bcredits byte [dvs_func:plural $bcredits credit credits], file ratio $dvs_fserve(fratio) with $fcredits file [dvs_func:plural $fcredits credit credits]"
				}
			} ratio {
				switch -- $dvs_fserve(ratiotype)\
				0 {
					set replacement "No ratio"
				} 1 {
					set replacement "Byte ratio $dvs_fserve(bratio)"
				} 2 {
					set replacement "File ratio $dvs_fserve(fratio)"
				} 3 {
					set replacement "Byte ratio $dvs_fserve(bratio), file ratio $dvs_fserve(fratio)"
				}
			} cred {
				set bcredits [expr int([dvs_fserve:func:slots get $idx bcredits])]
				set fcredits [expr int([dvs_fserve:func:slots get $idx fcredits])]
				switch -- $dvs_fserve(ratiotype)\
				0 {
					set replacement "Unlimited credits"
				} 1 {
					set replacement "$bcredits byte [dvs_func:plural $bcredits credit credits]"
				} 2 {
					set replacement "$fcredits file [dvs_func:plural $fcredits credit credits]"
				} 3 {
					set replacement "$bcredits byte [dvs_func:plural $bcredits credit credits], $fcredits file [dvs_func:plural $fcredits credit credits]"
				}
			} bcred {
				set bcredits [expr int([dvs_fserve:func:slots get $idx bcredits])]
				switch -- $dvs_fserve(ratiotype)\
				0 {
					set replacement "Unlimited byte credits"
				} 1 {
					set replacement "$bcredits byte [dvs_func:plural $bcredits credit credits]"
				} 2 {
					set replacement "Unlimited byte credits"
				} 3 {
					set replacement "$bcredits byte [dvs_func:plural $bcredits credit credits]"
				}
			} fcred {
				set fcredits [expr int([dvs_fserve:func:slots get $idx fcredits])]
				switch -- $dvs_fserve(ratiotype)\
				0 {
					set replacement "Unlimited file credits"
				} 1 {
					set replacement "Unlimited file credits"
				} 2 {
					set replacement "$fcredits file [dvs_func:plural $fcredits credit credits]"
				} 3 {
					set replacement "$fcredits file [dvs_func:plural $fcredits credit credits]"
				}
			} time12 {
				set replacement [strftime "%I:%M %p"]
			} time24 {
				set replacement [strftime "%H:%M"]
			} date2 {
				set replacement [strftime %m-%d-%y]
			} date4 {
				set replacement [strftime %m-%d-%Y]
			} strdate {
				set replacement [strftime "%B %d, %Y"]
			} maxdl {
				set replacement $dvs_fserve(maxdloads)
			} maxul {
				set replacement $dvs_fserve(maxuploads)
			} maxtrans {
				set replacement $dvs_fserve(maxtrans)
			} trigcount {
				global dvs_fserve_stats
				set replacement $dvs_fserve_stats(uses)
			} filecount {
				global dvs_fserve_stats
				set replacement $dvs_fserve_stats(foffered)
			} filecntf {
				global dvs_fserve_stats
				set replacement [dvs_func:nformat $dvs_fserve_stats(foffered)]
			} kilocount {
				global dvs_fserve_stats
				set replacement $dvs_fserve_stats(koffered)
			} kilocntf {
				global dvs_fserve_stats
				set replacement $dvs_fserve_stats(koffered)
			} megcount {
				global dvs_fserve_stats
				set replacement [format %.3f [expr $dvs_fserve_stats(koffered) / 1024]]
			} megcntf {
				global dvs_fserve_stats
				set replacement [dvs_func:nformat [format %.3f [expr $dvs_fserve_stats(koffered) / 1024]]]
			} backsp {
				set backsp 1
			} default {
				set replacement ""
			}
			if {$backsp} then {
				set line [string replace $line [expr $idx1 - 1] $idx2]
			} else {
				set line [string replace $line $idx1 [expr $idx2 - 1] $replacement]
			}
			#set line [lreplace $line $match $match $replacement]
		}
		#while {[set match [lsearch $line ${temp}!percent]] != -1} {
		#	set line [lreplace $line $match $match %]
		#}
		#set line [split [join $line]]
		#while {[set match [lsearch $line ${temp}!backsp]] != -1} {
		#	set tlength [string length ${temp}!backsp]
		#	set line1 [lrange $line 0 $match]
		#	set slength [string length $line1]
		#	set line1 [string range $line1 0 [expr $slength - $tlength - 2]]
		#	set line2 [string range [lrange $line $match end] [expr $tlength + 1] end]
		#	set line $line1$line2
		#}
		#set line [join $line]
		putdcc $idx $line
	}
	close $infile
	return
}

### PUB BINDS DATABASE ###
proc dvs_fserve:func:binds {} {
	global dvs_fserve dvs_fserve_binds
	
	# bind anything new
	foreach setting $dvs_fserve(triggers) {
		set type [lindex $setting 1]
		if {![info exists dvs_fserve_binds($setting)] && [dvs_func:imatch or $type "pub" "msg" "ctcp"]} then {
			set trigger   [lindex $setting 0]
			set bindflags [lindex $setting 2]
			bind $type $bindflags $trigger dvs_fserve:${type}:fserve
			set dvs_fserve_binds($setting) $setting
		}
	}
	
	# unbind everything else
	foreach setting [array names dvs_fserve_binds] {
		set found 0
		foreach sett $dvs_fserve(triggers) {
			if {[lrange $sett 0 1] == [lrange $setting 0 1]} then {
				set found 1
				break
			}
		}
		if {$found} then {
			continue
		}
		set trigger   [lindex $setting 0]
		set type      [lindex $setting 1]
		set bindflags [lindex $setting 2]
		unbind $type $bindflags $trigger dvs_fserve:${type}:fserve
		unset dvs_fserve_binds($setting)
	}
	
	return
}

### FLOOD CONTROL ###
proc dvs_fserve:func:floodctrl {type {arg ""}} {
	global dvs_fserve dvs_fserve_floodratio dvs_fserve_flood
	set type [string tolower $type]
	if {![string match -nocase *dvs?fserve?func?floodctrl* [utimers]]} then {
		utimer 30 "dvs_fserve:func:floodctrl clean"
	}
	if {![dvs_func:imatch or $type "pub" "onjoin" "fserve" "clean"]} then {
		return "Invalid type"
	} elseif {$type == "fserve"} then {
		if {$arg == ""} then {
			return -1
		}
		if {![info exists dvs_fserve_flood($arg)]} then {
			set dvs_fserve_flood($arg) [unixtime]
			return 0
		}
		if {$dvs_fserve_floodratio(fserve) == "0:1"} then {
			return 0
		} elseif {$dvs_fserve_floodratio(fserve) == "0:0"} then {
			set x 7
			set y 7
		} else {
			set x [lindex [split $dvs_fserve_floodratio(fserve) :] 0]
			set y [lindex [split $dvs_fserve_floodratio(fserve) :] 1]
		}
		set element 0
		set templist ""
		foreach ts $dvs_fserve_flood($arg) {
			if {[unixtime] - $ts <= $y} then {
				lappend templist [lindex $dvs_fserve_flood($arg) $element]
			}
			incr element
		}
		set dvs_fserve_flood($arg) $templist
		lappend dvs_fserve_flood($arg) [unixtime]
		if {[llength $dvs_fserve_flood($arg)] >= $x} then {
			return 1
		} else {
			return 0
		}
	}
	if {$type == "clean"} then {
		set x [lindex [split $dvs_fserve_floodratio(fserve) :] 0]
		set y [lindex [split $dvs_fserve_floodratio(fserve) :] 1]
		foreach entry [array names dvs_fserve_flood] {
			if {![dvs_func:imatch or $entry "fserve" "onjoin" "pub" "clean"]} then {
				continue
			}
			set length [llength $dvs_fserve_flood($entry)]
			set element 1
			foreach ts $dvs_fserve_flood($entry) {
				if {[unixtime] - $ts <= $y} then {
					break
				} elseif {$element == $length} then {
					unset dvs_fserve_flood($entry)
					break
				} else {
					incr element
				}
			}
		}
		return 0
	} elseif {![info exists dvs_fserve_flood($type)]} then {
		set dvs_fserve_flood($type) [unixtime]
		return 0
	}
	if {$dvs_fserve_floodratio($type) == "0:1"} then {
		return 0
	} elseif {$dvs_fserve_floodratio($type) == "0:0"} then {
		switch -- $type\
		pub {
			set x 5
			set y 5
		} onjoin {
			set x 4
			set y 7
		}
	} else {
		set x [lindex [split $dvs_fserve_floodratio($type) :] 0]
		set y [lindex [split $dvs_fserve_floodratio($type) :] 1]
	}

	set element 0
	set templist ""
	foreach ts $dvs_fserve_flood($type) {
		if {[unixtime] - $ts <= $y} then {
			lappend templist [lindex $dvs_fserve_flood($type) $element]
		}
		incr element
	}
	set dvs_fserve_flood($type) $templist
	lappend dvs_fserve_flood($type) [unixtime]
	if {[llength $dvs_fserve_flood($type)] >= $x} then {
		return 1
	} else {
		return 0
	}
}

### ONJOIN ###
bind join -|- * dvs_fserve:join:onjoin
proc dvs_fserve:join:onjoin {nick uhost hand chan} {
	global dvs_fserve
	set found 0
	if {!$dvs_fserve(onjoin)} then {
		return 0
	}
	foreach channel $dvs_fserve(channels) {
		if {[string match -nocase $channel $chan]} then {
			set found 1
			break
		}
	}
	if {[matchattr $hand b] || !$found || ($dvs_fserve(validuser) && $hand == "*") || (!$dvs_fserve(enable) && !$dvs_fserve(ad_while_off)) || [dvs_fserve:func:floodctrl onjoin]} then {
		return 0
	}
	puthelp "NOTICE $nick :[dvs_fserve:func:adgen]"
	return 0
}

### CHANLINE COUNT RESET ###
proc dvs_fserve:func:linecount-clean {} {
	global dvs_fserve_linecount
		
	foreach chan [array names dvs_fserve_linecount] {
		if {![dvs_fserve:func:validchan $chan]} then {
			unset dvs_fserve_linecount($chan)
		}
	}
	if {![string match -nocase *dvs?fserve?func?linecount-clean* [utimers]]} then {
		utimer 20 dvs_fserve:func:linecount-clean
	}
}

### CHANNEL LINE COUNTER ###
bind pubm -|- * dvs_fserve:bind:chan-counter
bind join -|- * dvs_fserve:bind:chan-counter
bind part -|- * dvs_fserve:bind:chan-counter
bind sign -|- * dvs_fserve:bind:chan-counter
bind kick -|- * dvs_fserve:bind:chan-counter
bind nick -|- * dvs_fserve:bind:chan-counter
bind topc -|- * dvs_fserve:bind:chan-counter
bind ctcp -|- ACTION dvs_fserve:bind:chan-counter
bind raw -|- MODE dvs_fserve:raw:chan-counter

proc dvs_fserve:bind:chan-counter {args} {
	global dvs_fserve dvs_fserve_linecount

	set chan [string tolower [lindex $args 3]]

	if {![dvs_fserve:func:validchan $chan]} then {
		return
	}

	set found 0
	foreach timer [concat [utimers] [timers]] {
		if {[lindex [lindex $timer 1] 0] == "dvs_fserve:func:pub-ad" && [string tolower [lindex [lindex $timer 1] 1]] == $chan} then {
			set found 1
			break
		}
	}

	if {![info exists dvs_fserve_linecount($chan)]} then {
		set dvs_fserve_linecount($chan) 1
	} else {
		incr dvs_fserve_linecount($chan)
	}

	if {$found || $dvs_fserve_linecount($chan) < $dvs_fserve(ad_linemin)} then {
		return
	}
	
	set delay [dvs_fserve:func:chandelay $chan]
	if {[expr int($delay)] == $delay} then {
		timer $delay "dvs_fserve:func:pub-ad [split $chan]"
	} else {
		utimer [expr int($delay * 60 + .5)] "dvs_fserve:func:pub-ad [split $chan]"
	}

	if {!$dvs_fserve(enable) || !$dvs_fserve(ad)} then {
		return
	}

	puthelp "PRIVMSG $chan :[dvs_fserve:func:adgen]"
	set dvs_fserve_linecount($chan) 0
}

proc dvs_fserve:raw:chan-counter {from keyword text} {
	dvs_fserve:bind:chan-counter "" "" "" [dvs_func:sindex $text 0]
	return 0
}

### CHANNEL VALIDATION ###
proc dvs_fserve:func:validchan {channel} {
	global dvs_fserve
	
	foreach chan $dvs_fserve(channels) {
		if {[string match -nocase [lindex $chan 0] $channel]} then {
			return 1
		}
	}
	return 0
}

### CHANNEL DELAY FINDER ###
proc dvs_fserve:func:chandelay {channel} {
	global dvs_fserve
	
	foreach chan $dvs_fserve(channels) {
		if {[string match -nocase [lindex $chan 0] $channel]} then {
			return [lindex $chan 1]
		}
	}
	return 0
}

### ADVERTISEMENT INITIALIZATION ###
proc dvs_fserve:ad-init {} {
	global dvs_fserve dvs_fserve_linecount
	
	foreach timer [timers] {
		if {[lindex [lindex $timer 1] 0] == "dvs_fserve:func:pub-ad" && ![dvs_fserve:func:validchan [lindex [lindex $timer 1] 1]]} then {
			killtimer [lindex $timer 2]
		}
	}
	foreach utimer [utimers] {
		if {[lindex [lindex $utimer 1] 0] == "dvs_fserve:func:pub-ad" && ![dvs_fserve:func:validchan [lindex [lindex $utimer 1] 1]]} then {
			killutimer [lindex $utimer 2]
		}
	}

	foreach channel [channels] {
		if {![dvs_fserve:func:validchan $channel]} then {
			continue
		}
		set found 0
		foreach utimer [concat [utimers] [timers]] {
			if {[lindex [lindex $utimer 1] 0] == "dvs_fserve:func:pub-ad" && [string equal -nocase [lindex [lindex $utimer 1] 1] $channel]} then {
				set found 1
				break
			}
		}
		if {$found || [info exists dvs_fserve_linecount([string tolower $channel])] && $dvs_fserve_linecount([string tolower $channel])} then {
			continue
		}
		set delay [dvs_fserve:func:chandelay $channel]
		if {[expr int($delay)] == $delay} then {
			timer $delay "dvs_fserve:func:pub-ad [split $channel]"
		} else {
			utimer [expr int($delay * 60 + .5)] "dvs_fserve:func:pub-ad [split $channel]"
		}
	}
}


### TIMED ADVERTISEMENTS ###
proc dvs_fserve:func:pub-ad {channel} {
	global dvs_fserve_linecount dvs_fserve
	foreach timer [utimers] {
		if {[lindex [lindex $timer 1] 0] == "dvs_fserve:func:pub-ad"} then {
			killutimer [lindex $timer 2]
		}
	}
	foreach timer [timers] {
		if {[lindex [lindex $timer 1] 0] == "dvs_fserve:func:pub-ad"} then {
			killtimer [lindex $timer 2]
		}
	}
	
	if {![dvs_fserve:func:validchan $channel]} then {
		return 1
	}
	
	if {![info exists dvs_fserve_linecount($channel)] || $dvs_fserve_linecount($channel) < $dvs_fserve(ad_linemin)} then {
		return 2
	}

	set delay [dvs_fserve:func:chandelay $channel]
	if {[expr int($delay)] == $delay} then {
		timer $delay "dvs_fserve:func:pub-ad [split $channel]"
	} else {
		utimer [expr int($delay * 60 + .5)] "dvs_fserve:func:pub-ad [split $channel]"
	}

	if {!$dvs_fserve(enable) || !$dvs_fserve(ad)} then {
		return 3
	}

	puthelp "PRIVMSG $channel :[dvs_fserve:func:adgen]"
	set dvs_fserve_linecount($channel) 0
}

### HOST MASKER ###
proc dvs_func:maskhost {host options} {
	global dvs_max_nickchars dvs_max_identchars
	set options [split $options .]
	set arg1 [lindex $options 0]
	set arg2 [lindex $options 1]
	set arg3 [lindex $options 2]
	set nick [dvs_func:sindex $host 0 !]
	set ident [dvs_func:sindex $host 1 !@]
	set host [dvs_func:sindex $host 1 @]
	
	switch -- $arg1\
	n {
		set nickmask $nick
	} *n {
		set nickmask *[string range $nick [expr [string length $nick] - $dvs_max_nickchars + 1] end]
	} n* {
		set nickmask [string range $nick 0 [expr $dvs_max_nickchars - 2]]*
	} *n* {
		set nickmask [string range $nick 0 [expr $dvs_max_nickchars - 2]]*
		set nickmask *[string range $nickmask [expr [string length $nickmask] - $dvs_max_nickchars + 1] end]
	} * {
		set nickmask *
	} default {
		return "Invalid syntax"
	}
	
	switch -- $arg2\
	u {
		set identmask $ident
	} *u {
		if {[string length [string trimleft $ident ~]] > 0} then {
			set ident [string trimleft $ident ~]
		} elseif {[string length $ident] > 1} then {
			set ident [string range $ident 1 end]
		}
		set identmask *[string range $ident [expr [string length $ident] - $dvs_max_identchars + 1] end]
	} u* {
		set identmask [string range $ident 0 [expr $dvs_max_identchars - 2]]*
	} *u* {
		if {[string length [string trimleft $ident ~]] > 0} then {
			set ident [string trimleft $ident ~]
		} elseif {[string length $ident] > 1} then {
			set ident [string range $ident 1 end]
		}
		set identmask [string range $ident 0 [expr $dvs_max_identchars - 2]]*
		set identmask *[string range $identmask [expr [string length $identmask] - $dvs_max_identchars + 1] end]
	} * {
		set identmask *
	} default {
		return "Invalid syntax"
	}
	
	switch -- $arg3\
	h {
		set hostmask $host
	} *h {
		set hostmask [dvs_func:sindex [maskhost $host] 1 @]
	} * {
		set hostmask *
	} default {
		return "Invalid syntax"
	}
	
	return ${nickmask}!${identmask}@${hostmask}
}

### SINDEX & SRANGE (Returns index'th element of a string) ###
proc dvs_func:sindex {string index {split " "}} {
	return [lindex [split $string $split] $index]
}

proc dvs_func:srange {string first last {split " "}} {
	return [join [lrange [split $string $split] $first $last]]
}

#proc dvs_func:sindex {string index {split " "}} {
#	set string [join [split $string $split]]
#	return [lindex [dvs_func:strfilt $string] $index]
#}
#proc dvs_func:srange {string first last {split " "}} {
#	set string [join [split $string $split]]
#	return [join [lrange [dvs_func:strfilt $string] $first $last]]
#}

# Thanks alot to Bass (coder of bseen) who told me about this nice thing:
#proc dvs_func:strfilt {string} {
#	regsub -all -- \\\\ $string \\\\\\\\ string
#	regsub -all -- \\\[ $string \\\\\[ string
#	regsub -all -- \\\] $string \\\\\] string
#	regsub -all -- \\\} $string \\\\\} string
#	regsub -all -- \\\{ $string \\\\\{ string
#	regsub -all -- \\\" $string \\\\\" string
#	return $string
#}

### IMATCH ###
proc dvs_func:imatch {op var args} {
	switch -- $op\
	or {
		foreach arg $args {
			if {![string compare $var $arg]} then {
				return 1
			}
		}
		return 0
	} and {
		foreach arg $args {
			if {[string compare $var $arg]} then {
				return 0
			}
		}
		return 1
	} default {
		return -1
	}
}

### NUMBER FORMATTING ###
proc dvs_func:nformat {num} {
	if {![dvs_func:validnum $num]} then {
		return "Invalid number"
	}
	set int [lindex [split $num .] 0]
	set dec [lindex [split $num .] 1]
	if {$dec != ""} then {
		set es .
	} else {
		set es ""
	}
	set place [expr [string length $int] % 3]
	if {!$place} then {
		set place 3
	}
	set charnum 1
	foreach char [split $int {}] {
		if {$charnum == $place} then {
			append int2 ${char},
			set charnum 1
			set place 3
		} else {
			append int2 $char
			incr charnum
		}
	}
	return [string trimright $int2 ,]${es}$dec
}

### UNIXTIME WITH MS ###
proc dvs_func:unixtime {{unixtime ""} {clicks ""}} {
	if {$unixtime == ""} then {
		set unixtime [unixtime]
	}
	if {$clicks == ""} then {
		set clicks [clock clicks]
	}
	set n 0
	if {$clicks < 0} then {
		set clicks [expr abs($clicks)]
		set n 1
	}
	set ms [string range [expr [format "%.3f" [expr double(abs([clock clicks])) / 1000000]] * 1000] 2 4]
	if {$n} then {
		set ms [expr 1000 - $ms]
	}
	return $unixtime.$ms
}

### BOT IP ###
proc dvs_func:myip {{format "base256"}} {
	global nat-ip
	
	if {$format == "base256" || $format == "quad"} then {
		if {![info exists nat-ip] || ${nat-ip} == ""} then {
			return [dvs_func:longip-2-quad [myip]]
		} else {
			return ${nat-ip}
		}
	} elseif {$format == "long" || $format == "longip"} then {
		if {![info exists nat-ip] || ${nat-ip} == ""} then {
			return [myip]
		} else {
			set splitip [split ${nat-ip} .]
			set ip1 [lindex $splitip 0]
			set ip2 [lindex $splitip 1]
			set ip3 [lindex $splitip 2]
			set ip4 [lindex $splitip 3]
			return [format %u [expr $ip1*256*256*256 + $ip2*256*256 + $ip3*256 + $ip4]]
		}
	} else {
		return "Invalid type. Available types: base256 and quad, long and longip."
	}
}

### DIRECTORY WORK ###
proc dvs_fserve:func:dir {command dir {dir2 ""}} {
	global dvs_fserve_pwd dvs_fserve dvs_fserve_path
	
	switch -- $command\
	isin {
		if {$dir2 == ""} then {
			set dir2 $dvs_fserve_path
		}
		if {![file isdirectory $dir2]} then {
			return 0
		}
		catch {
			cd $dvs_fserve_path/$dir
		} pass1
		catch {
			cd $dir
		} pass2
		set pwd [pwd]
		if {![string length $pass1] && [string match $dir2* $pwd] || ![string length $pass2] && [string match $dir2* $pwd]} then {
			cd $dvs_fserve_pwd
			return $pwd
		} else {
			cd $dvs_fserve_pwd
			return 0
		}
	} isvalid {
		catch {
			set dvs_fserve_pwd [pwd]
			set dvs_fserve_temp1 [catch {cd $dvs_fserve(filepath)}]
			set dvs_fserve_path [pwd]
			set dvs_fserve_temp2 [catch {cd $dvs_fserve_pwd}]
		}
		return [expr !($dvs_fserve_temp1 || $dvs_fserve_temp2)]
	} relative {
		return /[string trim [string range $dir [string length $dvs_fserve_path] end] /]
	} default {
		return -1
	}
}

### FSERVE HELP ORGANIZATION ###
proc dvs_fserve:func:help {type {element "all"}} {
	global dvs_fserve

	switch -- $type\
	fs {
		set help_items {
			{"help"
				{###    help \[command\]\n  Displays a list of available commands.  If a command is specified, a detailed description on the command is given, if available.}}
			{"ls"
				{###    ls \[args\]\n  Displays a UNIX-style dir listing.  Supply -l to use a long listing format.}}
			{"dir"
				{###    dir\n  Displays an MS-DOS-style dir listing.}}
			{"get"
				{###    get <filename/mask>\n  Sends specified file(s) to a user if they have sufficient credits. Wildcards accepted.}}
			{"find"
				{###    find <mask>\n  Searches for files matching a mask.  Uses globbing rules.}}
			{"credits"
				{###    credits\n  Displays credits.}}
			{"stats"
				{###    stats\n  Displays Fileserver statistics and information.}}
			{"exit"
				{###    exit\n  Exits the Fserve.}}
			{"cd"
				{###    cd <directory>\n  Changes current directory. Wildcards accepted.}}
			{"pwd"
				{###    pwd\n  Displays current directory.}}
			{"who"
				{###    who\n  Displays a list of users currently on the Fserve.}}
			{"say"
				{###    say <message>\n  Sends a message to other users on the Fserve.}}
			{"login"
				{###    login <password>\n  Fserve janitor login.}}
			{"cp"
				{###    [u]cp[u] <[u]source[u]> <[u]destination[u]>\n  Copies file(s) or dir(s).  Wildcards accepted.  Janitor only.}}
			{"mv"
				{###    [u]mv[u] <[u]source[u]> <[u]destination[u]>\n  Moves file(s) or dir(s).  Wildcards accepted.  Janitor only.}}
			{"rm"
				{###    [u]rm[u] <[u]target[u]>\n  Deletes file(s).  Wildcards accepted.  Janitor only.}}
			{"rmdir"
				{###    [u]rmdir[u] <[u]target[u]>\n  Deletes dir(s).  Wildcards accepted.  Janitor only.}}
			{"mkdir"
				{###    [u]mkdir[u] <[u]directory[u]>\n  Attempts to create a directory.  Janitor only.}}
		}
	} dcc {
		set help_items {
			{"ban"
				{###    .jserv ban <hostmask>\n  Bans a user from the Fserve.}}
			{"bans"
				{###    .jserv bans \[hostmask\]\n  Displays all Fserve bans matching the hostmask.  Default hostmask is *!*@*}}
			{"bcast"
				{###    .jserv bcast <message>\n  Broadcasts a message to all Fserve users.}}
			{"give"
				{###    .jserv give <user> <element> <value>\n  Valid elements:\n  bcredits <value>  - Adds byte credits to user.\n  fcredits  - Adds file credits to user.\n  file  - Sends file to user.\n}}
			{"help"
				{###    .jserv help \[command\]\n  Displays a list of available commands.  If a command is specified, a detailed\n  description on the command is given, if available.}}
			{"kill"
				{###    .jserv kill <idx> \[reason\]\n  Disconnects user from the Fserve with an optional reason.}}
			{"msg"
				{###    .jserv msg <idx> <message>\n  Sends a message to a user.}}
			{"transfers"
				{###    .transfers \[nick\]\n  Lists DCC transfers.  If nick is specified, will only list transfers for given nick.}}
			{"unban"
				{###    .jserv unban <index>\n       .jserv unban 0 \[hostmask\]\n  Unbans the indexed Fserve ban.  If index is 0, then all bans matching the\n  hostmask will be deleted.  Default hostmask is *!*@*}}
			{"who"
				{###    .jserv who\n  Lists the users on the Fserve and their idx's.}}
			{"uinfo"
				{###    .jserv uinfo <idx>\n  Gives info on a connected Fserve user.}}
			{"stats"
				{###    .jserv stats\n  Displays Fserve statistics.}}
		}
	} default {
		return "Invalid type."
	}
	
	if {$element == "all"} then {
		set length 0
		foreach entry $help_items {
			set elength [string length [lindex $entry 0]]
			if {$elength > $length} then {
				set length $elength
			}
		}
		incr length 2
		set items_per_line [expr int($dvs_fserve(maxchars) / $length)]
		if {!$items_per_line} then {
			incr items_per_line
		}
		set amount 0
		set string "Help for j[u][b]IRC[b]off[u] Fserve v[dvs_fserve:func:version version formatted]:\n\nCommands:\n    "
		foreach entry [lsort -index 0 -dictionary $help_items] {
			set entry [lindex $entry 0]
			set item [format %-${length}s $entry]
			if {$amount >= $items_per_line} then {
				append string "\n    $item"
				set amount 0
			} else {
				append string $item
			}
			incr amount
		}
		return $string
	}
	
	set found 0
	set index 0
	set element [string tolower $element]
	foreach entry $help_items {
		if {$element == [string tolower [lindex $entry 0]]} then {
			set found 1
			break
		}
		incr index
	}
	if {!$found} then {
		return "Invalid help item."
	}
	set message [lindex [lindex $help_items $index] 1]
	if {$message == ""} then {
		return "No help available on that."
	}
	return [subst $message]
}

### FSERVE SIZE CALCULATION ###
proc dvs_fserve:func:du {} {
	global dvs_fserve_stats dvs_fserve_path
	set err [catch {
		set dvs_fserve_stats(koffered) [lindex [exec du -s $dvs_fserve_path] 0]
	} result]
	if {$err} then {
		return
	}
	set files 0
	foreach entry [split [exec du -a $dvs_fserve_path] \n] {
		# Me stupid? heh.
		# set name [lindex $entry 1]
		set name [dvs_func:sindex $entry 1]
		if {![file isdirectory $name]} then {
			incr files
		}
	}
	set dvs_fserve_stats(foffered) $files
	if {![string match -nocase *dvs?fserve?func?du* [timers]]} then {
		timer 2 dvs_fserve:func:du
	}
	return
}

### DCC JSERV ###
# ban bans bcast give help kill msg transfers unban who stats uinfo {
proc dvs_fserve:dcc:jserv {hand idx text} {
	set keyword [string tolower [dvs_func:sindex $text 0]]
	set text [dvs_func:srange $text 1 end]
	
	switch -- $keyword\
	help {
		#dvs_fserve:func:dcc-help $idx $text
	} kill {
		#dvs_fserve:func:dcc-kill $idx $text
	} ban {
		#dvs_fserve:func:dcc-ban $idx $text
	} unban {
		#dvs_fserve:func:dcc-unban $idx $text
	} bans {
		#dvs_fserve:func:dcc-bans $idx $text
	} bcast {
		#dvs_fserve:func:dcc-bcast $idx $text
	} give {
		#dvs_fserve:func:dcc-give $idx $text
	} msg {
		#dvs_fserve:func:dcc-msg $idx $text
	} who {
		#dvs_fserve:func:dcc-who $idx
	} stats {
		#dvs_fserve:func:dcc-stats $idx $text
	} uinfo {
		#dvs_fserve:func:dcc-uinfo $idx $text
	}
	return 1
}

#proc dvs_fserve:func:dcc-help {idx text} {}


#proc dvs_fserve:func:dcc-kill {idx text} {}


#proc dvs_fserve:func:dcc-ban {idx text} {}


#proc dvs_fserve:func:dcc-unban {idx text} {}


#proc dvs_fserve:func:dcc-bans {idx text} {}


#proc dvs_fserve:func:dcc-bcast {idx text} {}


#proc dvs_fserve:func:dcc-give {idx text} {}


#proc dvs_fserve:func:dcc-msg {idx text} {}


#proc dvs_fserve:func:dcc-who {idx} {}


### FSERVE COMMANDS ###

## CD ##
proc dvs_fserve:func:fs-cd {idx dir} {
	global dvs_fserve dvs_fserve_path
	
	if {$dir == ""} then {
		putdcc $idx "Usage: cd <directory>"
		return
	}
	if {[string index $dir 0] == "/"} then {
		set pwd $dvs_fserve_path
	} else {
		set pwd [dvs_fserve:func:slots get $idx pwd]
	}
	set dests ""
	if {!$dvs_fserve(globcd)} then {
		set dir [dvs_func:pathdeglob $dir]
	}
	foreach entry [lsort -dictionary [glob -nocomplain -- [dvs_func:pathdeglob $pwd]/$dir]] {
		if {[file isdirectory $entry] && [dvs_fserve:func:dir isin $entry] != 0} then {
			lappend dests $entry
		}
	}
	if {$dests == ""} then {
		putdcc $idx "Invalid directory."
		return
	}
	
	if {![dvs_fserve:func:slots get $idx janitor]} then {
		foreach dest $dests {
			set jandeny 0
			foreach jdir $dvs_fserve(jdirs) {
				if {[dvs_fserve:func:dir isin $dest $jdir] != 0} then {
					set jandeny 1
					break
				} else {
					set jandeny 0
				}
			}
			if {!$jandeny} then {
				break
			}
		}
		if {$jandeny} then {
			putdcc $idx "You need to be logged on as janitor in order to access [dvs_fserve:func:dir relative $dest]"
			return
		}
	} else {
		set dest [lindex $dests 0]
	}

	set pwd [pwd]
	cd $dest
	set dest [pwd]
	cd $pwd

	dvs_fserve:func:slots set $idx pwd $dest
	putdcc $idx "### Directory changed to: [dvs_fserve:func:dir relative $dest]"
	return
}

## CREDITS ##
proc dvs_fserve:func:fs-credits {idx} {
	global dvs_fserve
	set bcredits [expr int([dvs_fserve:func:slots get $idx bcredits])]
	set fcredits [expr int([dvs_fserve:func:slots get $idx fcredits])]
	switch -- $dvs_fserve(ratiotype)\
	0 {
		set credits "Unlimited credits."
	} 1 {
		set credits "$bcredits byte [dvs_func:plural $bcredits credit credits], $dvs_fserve(bratio) byte ratio."
	} 2 {
		set credits "$fcredits file [dvs_func:plural $fcredits credit credits], $dvs_fserve(fratio) file ratio."
	} 3 {
		set credits "$bcredits byte [dvs_func:plural $bcredits credit credits], $dvs_fserve(bratio) byte ratio.\n  $fcredits file [dvs_func:plural $fcredits credit credits], $dvs_fserve(fratio) file ratio."
	}
	putdcc $idx "### Credits:\n  $credits"
	return
}

## DIR ##
proc dvs_fserve:func:fs-dir {idx} {
	global dvs_fserve dvs_fserve_path

	set pwd [dvs_fserve:func:slots get $idx pwd]
	set lpwd [pwd]
	catch {
		cd $pwd
	} result
	if {$result != ""} then {
		set pwd $dvs_fserve_path
		dvs_fserve:func:slots set $idx pwd $pwd
		cd $pwd
	}
	set ls [lsort -dictionary [glob -nocomplain -- ./*]]
	set length 0
	foreach entry $ls {
		set elength [string length [dvs_func:nformat [file size $entry]]]
		if {$elength > $length} then {
			set length $elength
		}
	}
	if {$length < 8} then {
		set length 8
	}
	putdcc $idx "### Directory of [dvs_fserve:func:dir relative $pwd]"
	set amt 0
	foreach entry $ls {
		if {[file isdirectory $entry]} then {
			set info [format %-${length}s <DIR>]
		} else {
			set info [format %${length}s [dvs_func:nformat [file size $entry]]]
		}
		set date [strftime %m-%d-%y [file mtime $entry]]
		set time [format %6s [string trim [string tolower [strftime %I:%M%p [file mtime $entry]]] 0m]]
		putdcc $idx "  $info  $date $time [file tail $entry]"
		incr amt
	}
	putdcc $idx "### $amt [dvs_func:plural $amt entry entries]"
	cd $lpwd
	return
}

## FIND ##
proc dvs_fserve:func:fs-find {idx mask} {
	global dvs_fserve
	
	if {$mask == ""} then {
		putdcc $idx "Usage: find <mask>"
		return
	}
	set pwd [dvs_fserve:func:slots get $idx pwd]
	putdcc $idx "Matches for $mask:"
	
	set count 0
	foreach element [dvs_func:ffind $pwd $mask [dvs_fserve:func:slots get $idx janitor]] {
		putdcc $idx [dvs_fserve:func:dir relative $element]
		incr count
	}
	putdcc $idx "Total matches: $count (max $dvs_fserve(maxmatches))"
	return
}

## GET ##
proc dvs_fserve:func:fs-get {idx mask} {
	global dvs_fserve max-dcc dvs_fserve_path dvs_fserve_stats max-dloads

	if {$mask == ""} then {
		putdcc $idx "Usage: get <file/mask>"
		return
	}
	if {[string index $mask 0] == "/"} then {
		set pwd $dvs_fserve_path
	} else {
		set pwd [dvs_fserve:func:slots get $idx pwd]
	}
	if {!$dvs_fserve(globget)} then {
		set mask [dvs_func:pathdeglob $mask]
	}

	set count 0
	set filelist ""
	foreach entry [lsort -dictionary [glob -nocomplain -- [split $pwd]/[split $mask]]] {
		set dir [file dirname $entry]
		if {[dvs_fserve:func:dir isin $dir] == 0 || ![file isfile $entry]} then {
			continue
		}
		foreach jdir $dvs_fserve(jdirs) {
			set result [dvs_fserve:func:dir isin $dir $jdir]
			if {$result != 0 && ![dvs_fserve:func:slots get $idx janitor]} then {
				continue
			}
		}
		lappend filelist $entry
		incr count
	}
	if {!$count} then {
		putdcc $idx "No matches."
		return
	}

	set nick [dvs_fserve:func:slots get $idx nick]
	set bcredits [dvs_fserve:func:slots get $idx bcredits]
	set fcredits [dvs_fserve:func:slots get $idx fcredits]

	set validcount 0
	set insuff 0
	set maxdl 0
	set maxtotaltrans 0
	set maxtrans 0
	set maxdcc 0
	set dccerror 0
	foreach entry $filelist {
		set size [file size $entry]
		set uploads [expr [lindex [dvs_fserve:func:transfers incoming $nick] 0] + [lindex [dvs_fserve:func:transfers pendin $nick] 0]]
		set downloads [expr [lindex [dvs_fserve:func:transfers outgoing $nick] 0] + [lindex [dvs_fserve:func:transfers pendout $nick] 0]]

		if {$dvs_fserve(ratiotype) == 1 && $size > $bcredits || \
			$dvs_fserve(ratiotype) == 2 && $fcredits < 1     || \
			$dvs_fserve(ratiotype) == 3 && $size > $bcredits && $fcredits < 1
		} then {
			incr insuff
			continue
		} elseif {${max-dcc} <= [dccused]} then {
			incr maxdcc
			continue
		} elseif {$dvs_fserve(maxsends) <= [lindex [dvs_fserve:func:transfers outgoing] 0] + [lindex [dvs_fserve:func:transfers pendout] 0]} then {
			incr maxtotaltrans
			continue
		} elseif {$downloads + $uploads >= $dvs_fserve(maxtrans) && ![dvs_fserve:func:slots get $idx janitor]} then {
			incr maxtrans
			continue
		} elseif {$downloads >= $dvs_fserve(maxdloads) && ![dvs_fserve:func:slots get $idx janitor] || $downloads >= ${max-dloads}} then {
			incr maxdl
			continue
		}
		if {$dvs_fserve(renspace)} then {
			set dirname [file dirname $entry]
			set filename [file tail $entry]
			set newname $filename
			if {[string match "* *" $filename]} then {
				set newname ""
				foreach char [split $filename {}] {
					if {$char == " " || $char == "\t"} then {
						append newname _
					} else {
						append newname $char
					}
				}
			}
			set entry $dirname/$newname
			if {$entry != [file join $dirname/$filename]} then {
				if {[file exists $entry]} then {
					incr dccerror
					continue
				}
				file rename -force -- $dirname/$filename $dirname/$newname
			}
		}
		#set oidx [dcclist]
		switch -- [dccsend $entry $nick]\
		0 {
			incr validcount
			putdcc $idx "Sending file: [file tail $entry] ([dvs_func:nformat [format %.3f [expr double($size) / 1024.0]]]k)"
			incr dvs_fserve_stats(fsnagged)
			set dvs_fserve_stats(ksnagged) [expr $dvs_fserve_stats(ksnagged) + double($size) / 1024.0]
			switch -- $dvs_fserve(ratiotype)\
			1 {
				incr bcredits -$size
				dvs_fserve:func:slots set $idx bcredits $bcredits
			} 2 {
				incr fcredits -1
				dvs_fserve:func:slots set $idx fcredits $fcredits
			} 3 {
				incr bcredits -$size
				incr fcredits -1
				dvs_fserve:func:slots set $idx bcredits $bcredits
				dvs_fserve:func:slots set $idx fcredits $fcredits
			}
			dvs_fserve:log:outgoing "Sending to <${idx}> (${nick}): ([dvs_func:nformat [format %.3f [expr double($size) / 1024.0]]]k) $entry"
		} 1 {
			continue
		} 2 {
			incr dccerror
			continue
		} 3 {
			continue
		} 4 {
			# Queued. That's not wanted, so the new idx has to be killed.
			# Too bad this damn shit doesn't work
			#foreach ix [dcclist] {
			#	set fnd 0
			#	foreach i $oidx {
			#		if {[lindex $i 0] == [lindex $ix 0]} then {
			#			set fnd 1
			#			break
			#		}
			#	}
			#	if {!$fnd} then {
			#		killdcc [lindex $ix 0]
			#		break
			#	}
			#}
			continue
		}
	}
	putdcc $idx "$validcount out of $count matches sent."
	if {$insuff} then {
		putdcc $idx "$insuff [dvs_func:plural $insuff "match was" "matches were"] denied due to insufficient credits."
	}
	if {$maxdcc} then {
		putdcc $idx "$maxdcc [dvs_func:plural $maxdcc "match was" "matches were"] denied because there were no dcc slots available."
	}
	if {$maxtotaltrans} then {
		putdcc $idx "$maxtotaltrans [dvs_func:plural $maxtotaltrans "match was" "matches were"] denied because I have too many outgoing transfers."
	}
	if {$maxtrans} then {
		putdcc $idx "$maxtrans [dvs_func:plural $maxtrans "match was" "matches were"] denied because you had too many dcc transfers."
	}
	if {$maxdl} then {
		putdcc $idx "$maxdl [dvs_func:plural $maxdl "match was" "matches were"] denied because you had too many downloads."
	}
	if {$dccerror} then {
		putdcc $idx "$dccerror [dvs_func:plural $dccerror "match was" "matches were"] denied because there were problem(s) processing the file or establishing DCC connection."
	}
	return
}	

## LOGIN ##
proc dvs_fserve:func:fs-login {idx text} {
	global dvs_fserve
	
	set nick [dvs_fserve:func:slots get $idx nick]
	set user [finduser $nick![dvs_fserve:func:slots get $idx host]]
	if {$user == "*" || ![matchattr $user $dvs_fserve(janflags)]} then {
		putdcc $idx "You're not a valid user."
		return
	} elseif {[dvs_fserve:func:slots get $idx janitor]} then {
		putdcc $idx "You already have Janitor priveleges."
		return
	} elseif {$text == ""} then {
		putdcc $idx "Usage: login <password>"
		return
	} elseif {![passwdok $user $text]} then {
		putdcc $idx "Incorrect password."
		return
	}
	dvs_fserve:func:slots set $idx janitor 1
	putdcc $idx "### You now have Janitor priveleges."
	return
}

## LS ##
proc dvs_fserve:func:fs-ls {idx text} {
	global dvs_fserve dvs_fserve_path
	
	set pwd [dvs_fserve:func:slots get $idx pwd]
	set lpwd [pwd]
	catch {
		cd $pwd
	} result
	if {$result != ""} then {
		set pwd $dvs_fserve_path
		dvs_fserve:func:slots set $idx pwd $pwd
		cd $pwd
	}
	if {$idx == "" || ($text != "-l" && $text != "")} then {
		putdcc $idx "### Usage: ls \[-l\]"
		cd $lpwd
		return
	} elseif {$text == "-l"} then {
		set length 0
		set ls [lsort -dictionary [glob -nocomplain -- ./*]]
		foreach entry $ls {
			set elength [string length [file size $entry]]
			if {$elength > $length} then {
				set length $elength
			}
		}
		putdcc $idx "### \[[dvs_fserve:func:dir relative $idx]\]"
		set amt 0
		foreach entry $ls {
			set size [format %${length}s [file size $entry]]
			set name [file tail $entry]
			if {[file isdirectory $entry]} then {
				append name /
			}
			putdcc $idx "  $size  [strftime "%b %d %H:%M" [file mtime $entry]] $name"
			incr amt
		}
		putdcc $idx "### $amt [dvs_func:plural $amt entry entries]"
		cd $lpwd
		return
	}
	set length 0
	set dir ""
	foreach entry [lsort -dictionary [glob -nocomplain -- ./*]] {
		set name [file tail $entry]
		if {[file isdirectory $entry]} then {
			append name /
		}
		set elength [string length $name]
		if {$elength > $length} then {
			set length $elength
		}
		lappend dir $name
	}
	incr length 2
	set items_per_line [expr int($dvs_fserve(maxchars) / $length)]
	if {!$items_per_line} then {
		incr items_per_line
	}
	set amount 0
	putdcc $idx "### \[[dvs_fserve:func:dir relative $idx]\]  "
	set string "  "
	set amt 0
	foreach entry $dir {
		set item [format %-${length}s $entry]
		if {$amount >= $items_per_line} then {
			append string "\n  $item"
			set amount 0
		} else {
			append string $item
			incr amount
		}
		incr amt
	}
	putdcc $idx $string
	putdcc $idx "### $amt [dvs_func:plural $amt entry entries]"
	cd $lpwd
	return
}

## SAY ##
proc dvs_fserve:func:fs-say {idx text} {
	if {[string trim $text] == ""} then {
		putdcc $idx "Usage: say <message>"
		return
	}
	set nick [dvs_fserve:func:slots get $idx nick]
	dvs_fserve:func:uinfo say $idx "<$nick> $text"
	putdcc $idx "Said: $text"
	dvs_fserve:log:chatter "<$idx> <$nick> $text"
	return
}
	
## STATS ##
proc dvs_fserve:func:fs-stats {idx} {
	global dvs_fserve_stats dvs_fserve

	set nick [dvs_fserve:func:slots get $idx nick]
	set ko [dvs_func:nformat $dvs_fserve_stats(koffered)]
	set fo [dvs_func:nformat $dvs_fserve_stats(foffered)]
	set msnagged [dvs_func:nformat [format %.3f [expr $dvs_fserve_stats(ksnagged) / 1024.0]]]
	set fsnagged [dvs_func:nformat $dvs_fserve_stats(fsnagged)]
	set bcredits [expr int($dvs_fserve(startbcredits))]
	set fcredits [expr int($dvs_fserve(startfcredits))]
	
	putdcc $idx "### Fserve v[dvs_fserve:func:version version formatted] \[[dvs_fserve:func:version ts date]\] by DVS01. Stats:"
	putdcc $idx "Fserve was triggered $dvs_fserve_stats(uses) [dvs_func:plural $dvs_fserve_stats(uses) time times]."
	putdcc $idx "KB offered: $ko"
	putdcc $idx "File(s) offered: $fo"
	putdcc $idx "File(s) snagged: $fsnagged.  Meg(s) snagged: $msnagged"
	
	switch -- $dvs_fserve(ratiotype)\
	0 {
		putdcc $idx "No ratio."
	} 1 {
		putdcc $idx "$dvs_fserve(bratio) byte ratio.\n  $bcredits initial byte [dvs_func:plural $bcredits credit credits]."
	} 2 {
		putdcc $idx "$dvs_fserve(fratio) file ratio.\n  $fcredits initial file [dvs_func:plural $fcredits credit credits]."
	} 3 {
		putdcc $idx "$dvs_fserve(bratio) byte ratio.\n  $dvs_fserve(fratio) file ratio.\n  $bcredits initial byte [dvs_func:plural $bcredits credit credits].\n  $fcredits initial file [dvs_func:plural $fcredits credit credits]."
	}
	putdcc $idx [dvs_fserve:func:transfers formatted]
	return
}
	
## WHO ##
proc dvs_fserve:func:fs-who {idx} {
	global dvs_fserve_slots
	set amt 0
	foreach entry [dvs_fserve:func:uinfo who] {
		append nicklist "[dvs_fserve:func:slots get $entry nick], "
		incr amt
	}
	set nicklist [string trimright [join [lsort -dictionary $nicklist]] ", "]
	putdcc $idx "$amt [dvs_func:plural $amt User Users] online: $nicklist"
	return
}

### FSERVE JANITOR COMMANDS ###

## CP ##
proc dvs_fserve:func:fs-cp {idx src dest} {
	global dvs_fserve_path

	if {![dvs_fserve:func:slots get $idx janitor]} then {
		putdcc $idx "You must be logged in as a janitor in order to use this function."
		return
	} elseif {$dest == ""} then {
		putdcc $idx "Usage: cp <source> <destination>"
		return
	}

	set pwd1 [dvs_fserve:func:slots get $idx pwd]
	if {[string index $src 0] == "/"} then {
		set pwd1 $dvs_fserve_path
	}
	set pwd2 [dvs_fserve:func:slots get $idx pwd]
	if {[string index $dest 0] == "/"} then {
		set pwd2 $dvs_fserve_path
	}
	set scount 0
	set dcount 0
	set copycount 0
	set srclist ""
	set destlist ""
	#foreach entry [glob -nocomplain -- [split $pwd1]/[split $src]]
	foreach entry [glob -nocomplain -- [dvs_func:pathdeglob $pwd1]/$src] {
		set dir [file dirname $entry]
		if {[file isfile $entry] && [dvs_fserve:func:dir isin $dir] == 0 || [file isdirectory $entry] && [dvs_fserve:func:dir isin $entry] == 0} then {
			continue
		}
		lappend srclist $entry
		incr scount
	}
	foreach entry [glob -nocomplain -- [dvs_func:pathdeglob $pwd2]/$dest] {
		set dir [file dirname $entry]
		if {[file isfile $entry] && [dvs_fserve:func:dir isin $dir] == 0 || [file isdirectory $entry] && [dvs_fserve:func:dir isin $entry] == 0} then {
			continue
		}
		lappend destlist $entry
		incr dcount
	}
	if {$destlist == ""} then {
		lappend destlist $pwd2/$dest
	}

	foreach dst $destlist {
		foreach sc $srclist {
			if {$sc != $dst} then {
				catch {
					file copy -force -- $sc $dst
				} result
				if {$result == ""} then {
					incr copycount
				}
			}
		}
	}
	putdcc $idx "### Copied $copycount [dvs_func:plural $copycount object objects] out of $scount total matching [dvs_func:plural $scount object objects] to $dcount matching [dvs_func:plural $dcount destination destinations]."
	return
}

## MKDIR ##
proc dvs_fserve:func:fs-mkdir {idx dest} {
	global dvs_fserve_path

	if {![dvs_fserve:func:slots get $idx janitor]} then {
		putdcc $idx "You must be logged in as a janitor in order to use this function."
		return
	} elseif {$dest == ""} then {
		putdcc $idx "Usage: mkdir <destination>"
		return
	}
	set pwd [dvs_fserve:func:slots get $idx pwd]
	if {[string index $dest 0] == "/"} then {
		set pwd $dvs_fserve_path
	}
	set count 0
	set dirs [file dirname $dest]
	set dst [file tail $dest]
	set result [glob -nocomplain -- [dvs_func:pathdeglob $pwd]/$dirs]
	if {[llength $result] <= 1} then {
		putdcc $idx "### Single dir mode."
		if {$result == ""} then {
			catch {
				set exists [file exists $dvs_fserve_path/$dest]
				file mkdir $dvs_fserve_path/$dest
				set dst $dvs_fserve_path
			} result
		} else {
			catch {
				set exists [file exists $result/$dst]
				file mkdir $result/$dst
				set dst $result
			} result
		}
		if {$result != "" || $exists} then {
			putdcc $idx "Destination already exists."
			return
		} elseif {[dvs_fserve:func:dir isin $dst] == 0} then {
			file delete -force -- $dst/$dest
			putdcc $idx "Invalid path."
			return
		}
		putdcc $idx "### Created dir: [dvs_fserve:func:dir relative [file dirname $dst]/$dest]"
		return
	} else {
		putdcc $idx "### Multidir mode."
		foreach entry $result {
			set dir [file dirname $entry]
			if {[dvs_fserve:func:dir isin $dir] == 0 || [file exists $entry/$dst]} then {
				continue
			}
			file mkdir $entry/$dst
			putdcc $idx "Created [dvs_fserve:func:dir relative $entry/$dst]"
			incr count
		}
		putdcc $idx "### Created $count [dvs_func:plural $count dir dirs]"
		return
	}
}

## MV ##
proc dvs_fserve:func:fs-mv {idx src dest} {
	global dvs_fserve_path

	if {![dvs_fserve:func:slots get $idx janitor]} then {
		putdcc $idx "You must be logged in as a janitor in order to use this function."
		return
	} elseif {$dest == ""} then {
		putdcc $idx "Usage: mv <source> <destination>"
		return
	}

	set pwd1 [dvs_fserve:func:slots get $idx pwd]
	if {[string index $src 0] == "/"} then {
		set pwd1 $dvs_fserve_path
	}
	set pwd2 [dvs_fserve:func:slots get $idx pwd]
	if {[string index $dest 0] == "/"} then {
		set pwd2 $dvs_fserve_path
	}
	set scount 0
	set dcount 0
	set movecount 0
	set srclist ""
	set destlist ""
	foreach entry [glob -nocomplain -- [dvs_func:pathdeglob $pwd1]/$src] {
		set dir [file dirname $entry]
		if {[file isfile $entry] && [dvs_fserve:func:dir isin $dir] == 0 || [file isdirectory $entry] && [dvs_fserve:func:dir isin $entry] == 0} then {
			continue
		}
		lappend srclist $entry
		incr scount
	}
	foreach entry [glob -nocomplain -- [dvs_func:pathdeglob $pwd2]/$dest] {
		set dir [file dirname $entry]
		if {[file isfile $entry] && [dvs_fserve:func:dir isin $dir] == 0 || [file isdirectory $entry] && [dvs_fserve:func:dir isin $entry] == 0} then {
			continue
		}
		lappend destlist $entry
		incr dcount
	}
	if {$destlist == ""} then {
		lappend destlist $pwd2/$dest
	}

	foreach dst $destlist {
		foreach sc $srclist {
			if {$sc != $dst} then {
				catch {
					file rename -force -- $sc $dst
				} result
				if {$result == ""} then {
					incr movecount
				}
			}
		}
	}
	putdcc $idx "### Moved $movecount [dvs_func:plural $movecount object objects] out of $scount total matching [dvs_func:plural $scount object objects] to $dcount matching [dvs_func:plural $dcount destination destinations]."
	return
}

## RM ##
proc dvs_fserve:func:fs-rm {idx dest} {
	if {![dvs_fserve:func:slots get $idx janitor]} then {
		putdcc $idx "You must be logged in as a janitor in order to use this function."
		return
	} elseif {$dest == ""} then {
		putdcc $idx "Usage: rm <target>"
		return
	}

	global dvs_fserve_path
	set pwd [dvs_fserve:func:slots get $idx pwd]
	if {[string index $dest 0] == "/"} then {
		set pwd $dvs_fserve_path
	}
	set count 0
	foreach entry [glob -nocomplain -- [dvs_func:pathdeglob $pwd]/$dest] {
		set dir [file dirname $entry]
		if {[dvs_fserve:func:dir isin $dir] == 0 || ![file isfile $entry]} then {
			continue
		}
		file delete -- $entry
		incr count
	}
	putdcc $idx "### Deleted $count [dvs_func:plural $count file files]"
	return
}



## RMDIR ##
proc dvs_fserve:func:fs-rmdir {idx dest} {
	if {![dvs_fserve:func:slots get $idx janitor]} then {
		putdcc $idx "You must be logged in as a janitor in order to use this function."
		return
	} elseif {$dest == ""} then {
		putdcc $idx "Usage: rm <target>"
		return
	}

	global dvs_fserve_path
	set pwd [dvs_fserve:func:slots get $idx pwd]
	if {[string index $dest 0] == "/"} then {
		set pwd $dvs_fserve_path
	}
	set count 0
	foreach entry [glob -nocomplain -- [dvs_func:pathdeglob $pwd]/$dest] {
		if {[dvs_fserve:func:dir isin $entry] == 0 || [dvs_fserve:func:dir isin $entry] == $dvs_fserve_path || ![file isdirectory $entry]} then {
			continue
		}
		file delete -force -- $entry
		putdcc $idx "Deleted dir: [dvs_fserve:func:dir relative $entry]"
		incr count
	}
	putdcc $idx "### Deleted $count [dvs_func:plural $count dir dirs]"
	return
}

### FSERVE USERLIST MANAGEMENT ###
proc dvs_fserve:func:userlist {command user {element ""} {data ""}} {
	global dvs_fserve_users
	set command [string tolower $command]
	set user [string tolower $user]
	set element [string tolower $element]
	set data [string tolower $data]
	switch -- $command\
	set {
		if {$data == "" || $element == "" || [llength $data] > 3 || (![info exists dvs_fserve_users($user)] && $element != "all" && $command != "exists") || $command != "exists" && (![dvs_func:imatch or $element "all" "ts" "bcredits" "fcredits"])} then {
			return -1
		} elseif {$element == "all"} then {
			if {[llength $data] != 3 || ![dvs_func:validnum [lindex $data 0]] || ![dvs_func:validnum [lindex $data 1]] || ![dvs_func:validnum [lindex $data 2]]} then {
				return -1
			}
			set dvs_fserve_users($user) $data
			return 1
		} elseif {[llength $data] > 1} then {
			return -1
		}
		switch -- $element\
		ts {
			set index 0
		} bcredits {
			if {![dvs_func:validnum $data]} then {
				return -1
			}
			set index 1
		} fcredits {
			if {![dvs_func:validnum $data]} then {
				return -1
			}
			set index 2
		}
		set dvs_fserve_users($user) [lreplace $dvs_fserve_users($user) $index $index $data]
		return 1
	} get {
		if {![info exists dvs_fserve_users($user)]} then {
			return 0
		} elseif {![dvs_func:imatch or $element "all" "ts" "bcredits" "fcredits"]} then {
			return -1
		} elseif {$element == "all"} then {
			return $dvs_fserve_users($user)
		}
		switch -- $element\
		ts {
			set index 0
		} bcredits {
			set index 1
		} fcredits {
			set index 2
		}
		return [lindex $dvs_fserve_users($user) $index]
	} exists {
		if {![info exists dvs_fserve_users($user)]} then {
			return 0
		} else {
			return 1
		}
	} default {
		return -1
	}
}

proc dvs_fserve:func:usercleanup {} {
	global dvs_fserve dvs_fserve_users
	foreach user [array names dvs_fserve_users] {
		if {[unixtime] - [lindex $dvs_fserve_users($user) 0] >= ($dvs_fserve(expireuser) * 60) && [dvs_fserve:func:slots isonfserve $user masked] >= 1} then {
			unset dvs_fserve_users($user)
		}
	}
	if {![string match -nocase *dvs?fserve?func?usercleanup* [utimers]]} then {
		utimer 30 dvs_fserve:func:usercleanup
	}
}

### FSERVE SLOTS MANAGEMENT ###
proc dvs_fserve:func:slots {command idx {element ""} {data ""}} {
	global dvs_fserve_slots
	set command [string tolower $command]
	switch -- $command\
	set {
		if {$data == "" || $element == "" || [llength $data] > 7 || (![info exists dvs_fserve_slots($idx)] && $element != "all" && $command != "isonfserve") || ($command != "isonfserve" && ![dvs_func:imatch or $element "all" "nick" "mask" "bcredits" "fcredits" "pwd" "idle" "janitor"])} then {
			return -1
		} elseif {$element == "all"} then {
			if {[llength $data] != 7 || ![dvs_func:validnum [lindex $data 2]] || ![dvs_func:validnum [lindex $data 3]] || ![dvs_func:validnum [lindex $data 5]] || ![dvs_func:validnum [lindex $data 6]]} then {
				return -1
			}
			set dvs_fserve_slots($idx) $data
			return 1
		}
		switch -- $element\
		nick {
			set index 0
		} host {
			set index 1
		} bcredits {
			if {![dvs_func:validnum $data]} then {
				return -1
			}
			set index 2
		} fcredits {
			set index 3
			if {![dvs_func:validnum $data]} then {
				return -1
			}
		} pwd {
			set index 4
		} idle {
			set index 5
			if {![dvs_func:validnum $data]} then {
				return -1
			}
		} janitor {
			set index 6
			if {$data != 0 && $data != 1} then {
				return -1
			}
		}
		set dvs_fserve_slots($idx) [lreplace $dvs_fserve_slots($idx) $index $index $data]
		return 1
	} get {
		if {![info exists dvs_fserve_slots($idx)]} then {
			return 0
		} elseif {![dvs_func:imatch or $element "all" "nick" "host" "bcredits" "fcredits" "pwd" "idle" "janitor"]} then {
			return -1
		} elseif {$element == "all"} then {
			return $dvs_fserve_slots($idx)
		}
		switch -- $element\
		nick {
			set index 0
		} host {
			set index 1
		} bcredits {
			set index 2
		} fcredits {
			set index 3
		} pwd {
			set index 4
		} idle {
			set index 5
		} janitor {
			set index 6
		}
		return [lindex $dvs_fserve_slots($idx) $index]
	} isonfserve {
		if {![info exists dvs_fserve_slots]} then {
			return 0
		} elseif {$element == "masked"} then {
			set idx [dvs_func:maskhost n!$idx *.*u.*h]
		}
		set idx [string tolower $idx]
		set count 0
		foreach entry [array names dvs_fserve_slots] {
			if {[string match -nocase $idx [lindex $dvs_fserve_slots($entry) 1]]} then {
				incr count
			}
		}
		return $count
	} addpend {
		if {$idx == ""} then {
			return -1
		} elseif {![info exists dvs_fserve_slots(pending)]} then {
			set dvs_fserve_slots(pending) ""
		}
		lappend dvs_fserve_slots(pending) "[unixtime] $idx"
	} delpend {
		if {$idx == ""} then {
			return -1
		} elseif {![info exists dvs_fserve_slots(pending)]} then {
			return
		}
		set success 0
		set templist ""
		foreach entry [string tolower $dvs_fserve_slots(pending)] {
			if {[string tolower [lindex $entry 1]] == [string tolower $idx] && !$success} then {
				set success 1
			} else {
				lappend templist $entry
			}
		}
		set dvs_fserve_slots(pending) $templist
		return
	} ispend {
		if {![info exists dvs_fserve_slots(pending)]} then {
			return 0
		}
		set count 0
		foreach entry [string tolower $dvs_fserve_slots(pending)] {
			if {[string tolower [lindex $entry 1]] == [string tolower $idx]} then {
				incr count
			}
		}
		return $count
	} default {
		return -1
	}
}

proc dvs_fserve:func:pendclean {} {
	global dvs_fserve_slots
	if {![info exists dvs_fserve_slots(pending)]} then {
		return
	}
	foreach entry $dvs_fserve_slots(pending) {
		if {[unixtime] - [lindex $entry 0] >= 30} then {
			dvs_fserve:func:slots delpend [lindex $entry 1]
		}
	}
	if {![string match -nocase *dvs?fserve?func?pendclean* [utimers]]} then {
		utimer 30 dvs_fserve:func:pendclean
	}
}

### STATS INIT ###
proc dvs_fserve:func:stats-init {} {
	global dvs_fserve dvs_fserve_stats
	
	foreach element [dvs_fserve:func:settings-info elements] {
		set keyword [lindex $element 0]
		set format [lindex $element 1]
		if {![info exists dvs_fserve_stats($keyword)]} then {
			set dvs_fserve_stats($keyword) [dvs_func:null $format]
		}
	}

	if {![info exists dvs_fserve_stats(reenable)]} then {
		set dvs_fserve_stats(reenable) 0
	}
	if {![info exists dvs_fserve_stats(wasenabled)]} then {
		set dvs_fserve_stats(wasenabled) $dvs_fserve(enable)
	}
	if {![info exists dvs_fserve_stats(lock)]} then {
		set dvs_fserve_stats(lock) 0
	}
	return
}

### DCC TRANSFERS ###
bind dcc j|- transfers dvs_dcc:transfers
proc dvs_dcc:transfers {hand idx text} {
	putdcc $idx [dvs_fserve:func:transfers formatted $text]
	return 1
}

proc dvs_fserve:func:transfers {type {nick ""}} {
	switch -- $type\
	incoming {
		set sends 0
		set output ""
		foreach entry [dcclist SEND] {
			if {$nick != "" && [string tolower [lindex $entry 1]] != [string tolower $nick]} then {
				continue
			}
			set olist ""
			set file [lrange [lindex $entry 4] 2 end]
			set whom [lindex $entry 1]
			set sent [string trim [lindex [split [lindex [lindex $entry 4] 1] /] 0] ()]
			set total [lindex [split [lindex [lindex $entry 4] 1] /] 1]
			lappend olist $whom $file $sent $total
			lappend output $olist
			incr sends
		}
		set output [linsert [lsort -dictionary -index 1 $output] 0 $sends]
		return $output
	} outgoing {
		set gets 0
		set output ""
		foreach entry [dcclist GET] {
			if {$nick != "" && [string tolower [lindex $entry 1]] != [string tolower $nick]} then {
				continue
			}
			set olist ""
			set file [lrange [lindex $entry 4] 2 end]
			set whom [lindex $entry 1]
			set sent [string trim [lindex [split [lindex [lindex $entry 4] 1] /] 0] ()]
			set total [lindex [split [lindex [lindex $entry 4] 1] /] 1]
			lappend olist $whom $file $sent $total
			lappend output $olist
			incr gets
		}
		set output [linsert [lsort -dictionary -index 1 $output] 0 $gets]
		return $output
	} pendin {
		set sends 0
		set output ""
		foreach entry [dcclist SEND_PENDING] {
			if {$nick != "" && [string tolower [lindex $entry 1]] != [string tolower $nick]} then {
				continue
			}
			set olist ""
			set file [lrange [lindex $entry 4] 2 end]
			set whom [lindex $entry 1]
			set sent [string trim [lindex [split [lindex [lindex $entry 4] 1] /] 0] ()]
			set total [lindex [split [lindex [lindex $entry 4] 1] /] 1]
			lappend olist $whom $file $sent $total
			lappend output $olist
			incr sends
		}
		set output [linsert [lsort -dictionary -index 1 $output] 0 $sends]
		return $output
	} pendout {
		set gets 0
		set output ""
		foreach entry [dcclist GET_PENDING] {
			if {$nick != "" && [string tolower [lindex $entry 1]] != [string tolower $nick]} then {
				continue
			}
			set olist ""
			set file [lrange [lindex $entry 4] 2 end]
			set whom [lindex $entry 1]
			set sent [string trim [lindex [split [lindex [lindex $entry 4] 1] /] 0] ()]
			set total [lindex [split [lindex [lindex $entry 4] 1] /] 1]
			lappend olist $whom $file $sent $total
			lappend output $olist
			incr gets
		}
		set output [linsert [lsort -dictionary -index 1 $output] 0 $gets]
		return $output
	} formatted {
		set incoming [dvs_fserve:func:transfers incoming $nick]
		set outgoing [dvs_fserve:func:transfers outgoing $nick]
		set incount [lindex $incoming 0]
		set outcount [lindex $outgoing 0]
		set incoming [lreplace $incoming 0 0]
		set outgoing [lreplace $outgoing 0 0]
		set output ""
		if {!$incount && $nick == ""} then {
			append output "### No incoming transfers."
		} elseif {!$incount && $nick != ""} then {
			append output "### No incoming transfers for $nick."
		} else {
			if {$nick == ""} then {
				append output "### Incoming transfers:"
			} else {
				append output "### Incoming transfers for $nick:"
			}
			foreach entry $incoming {
				set whom [lindex $entry 0]
				set filename [file tail [lindex $entry 1]]
				set sent [format %.3f [expr double([lindex $entry 2]) / 1024]]
				set total [format %.3f [expr double([lindex $entry 3]) / 1024]]
				set percentage [expr int($sent * 100 / $total)]
				append output "\n<- $filename from $whom.\n  [dvs_func:nformat $sent]k out of [dvs_func:nformat $total]k ($percentage%)."
			}
		}
		if {!$outcount && $nick == ""} then {
			append output "\n### No outgoing transfers."
		} elseif {!$outcount && $nick != ""} then {
			append output "\n### No outgoing transfers for $nick."
		} else {
			if {$nick == ""} then {
				append output "\n### Outgoing transfers:"
			} else {
				append output "\n### Outgoing transfers for $nick:"
			}
			foreach entry $outgoing {
				set whom [lindex $entry 0]
				set filename [file tail [lindex $entry 1]]
				set sent [format %.3f [expr double([lindex $entry 2]) / 1024]]
				set total [format %.3f [expr double([lindex $entry 3]) / 1024]]
				set percentage [expr int($sent * 100 / $total)]
				append output "\n-> $filename to $whom.\n  [dvs_func:nformat $sent]k out of [dvs_func:nformat $total]k ($percentage%)."
			}
		}
		if {$incount || $outcount} then {
			append output "\n### $incount DCC [dvs_func:plural $incount get gets], $outcount DCC [dvs_func:plural $outcount send sends]."
		}
		return $output
	} default {
		return -1
	}
}

### FSERVE TRIGGER RESPONSE ###
proc dvs_fserve:pub:fserve {nick uhost hand chan text} {
	global dvs_fserve max-dcc
	if {[matchattr $hand b] || ($dvs_fserve(validuser) && $hand == "*") || !$dvs_fserve(enable) || [dvs_fserve:func:floodctrl pub]} then {
		return 0
	}
	set banned 0
	foreach ban $dvs_fserve(bans) {
		if {[string match -nocase $ban ${nick}!${uhost}]} then {
			set banned 1
			break
		}
	}
	if {$banned} then {
		puthelp "NOTICE $nick :You are banned from the Fserve."
		return 0
	} elseif {[dccused] >= ${max-dcc}} then {
		puthelp "NOTICE $nick :Sorry, maximum amount of dcc slots are in use."
		return 0
	} elseif {[dvs_fserve:func:slotcount] < 1} then {
		puthelp "NOTICE $nick :Sorry, all slots are full ($dvs_fserve(maxslots))"
		return 0
	} elseif {([dvs_fserve:func:slots isonfserve $uhost] + [dvs_fserve:func:slots ispend $uhost]) >= $dvs_fserve(maxclone)} then {
		puthelp "NOTICE $nick :Maximum amount of connections from the same user has been reached."
		return 0
	}
	dvs_fserve:fserv:init $nick $uhost
	return 1
}
proc dvs_fserve:msg:fserve {nick uhost hand text} {
	global dvs_fserve max-dcc
	if {[matchattr $hand b] || ($dvs_fserve(validuser) && $hand == "*") || !$dvs_fserve(enable) || [dvs_fserve:func:floodctrl pub]} then {
		return 0
	}
	set banned 0
	foreach ban $dvs_fserve(bans) {
		if {[string match -nocase $ban ${nick}!${uhost}]} then {
			set banned 1
			break
		}
	}
	if {$banned} then {
		puthelp "NOTICE $nick :You are banned from the Fserve."
		return 0
	} elseif {[dccused] >= ${max-dcc}} then {
		puthelp "NOTICE $nick :Sorry, maximum amount of dcc slots are in use."
		return 0
	} elseif {[dvs_fserve:func:slotcount] < 1} then {
		puthelp "NOTICE $nick :Sorry, all slots are full ($dvs_fserve(maxslots))"
		return 0
	} elseif {([dvs_fserve:func:slots isonfserve $uhost] + [dvs_fserve:func:slots ispend $uhost]) >= $dvs_fserve(maxclone)} then {
		puthelp "NOTICE $nick :Maximum amount of connections from the same user has been reached."
		return 0
	}
	dvs_fserve:fserv:init $nick $uhost
	return 1
}
proc dvs_fserve:ctcp:fserve {nick uhost hand dest keyword text} {
	global dvs_fserve max-dcc
	if {[matchattr $hand b] || ($dvs_fserve(validuser) && $hand == "*") || !$dvs_fserve(enable) || [dvs_fserve:func:floodctrl pub]} then {
		return 0
	}
	set banned 0
	foreach ban $dvs_fserve(bans) {
		if {[string match -nocase $ban ${nick}!${uhost}]} then {
			set banned 1
			break
		}
	}
	if {$banned} then {
		puthelp "NOTICE $nick :You are banned from the Fserve."
		return 0
	} elseif {[dccused] >= ${max-dcc}} then {
		puthelp "NOTICE $nick :Sorry, maximum amount of dcc slots are in use."
		return 0
	} elseif {[dvs_fserve:func:slotcount] < 1} then {
		puthelp "NOTICE $nick :Sorry, all slots are full ($dvs_fserve(maxslots))"
		return 0
	} elseif {([dvs_fserve:func:slots isonfserve $uhost] + [dvs_fserve:func:slots ispend $uhost]) >= $dvs_fserve(maxclone)} then {
		puthelp "NOTICE $nick :Maximum amount of connections from the same user has been reached."
		return 0
	}
	dvs_fserve:fserv:init $nick $uhost
	return 1
}

### FSERVE INIT ###
proc dvs_fserve:fserv:init {nick uhost} {
	global numversion 
	
	putserv "NOTICE $nick :Initiating DCC chat..."
	dvs_fserve:func:slots addpend $uhost
	set port [listen 0 script null]
	listen $port off
	if {$numversion >= 1050000} then {
		listen $port script "dvs_fserve:listen:init [split $nick] [split $uhost] $port" pub
	} else {
		listen $port script "dvs_fserve:listen:init [split $nick] [split $uhost] $port"
	}
	utimer 30 "catch {listen $port off}"
	putserv "PRIVMSG $nick :\001DCC CHAT chat [dvs_func:myip long] $port\001"
	return 0
}

proc dvs_fserve:listen:init {nick uhost port idx} {
	global dvs_fserve dvs_fserve_path dvs_fserve_stats
	listen $port off
	dvs_fserve:func:slots delpend $uhost
	set hostmask [dvs_func:maskhost $nick!$uhost *.*u.*h]
	if {![dvs_fserve:func:userlist exists $hostmask]} then {
		dvs_fserve:func:userlist set $hostmask all "[unixtime] $dvs_fserve(startbcredits) $dvs_fserve(startfcredits)"
	}
	dvs_fserve:func:slots set $idx all "$nick $uhost [dvs_fserve:func:userlist get $hostmask bcredits] [dvs_fserve:func:userlist get $hostmask fcredits] $dvs_fserve_path [unixtime] 0"
	incr dvs_fserve_stats(uses)

	dvs_fserve:func:idleman $idx clean
	if {$dvs_fserve(maxidle) < 31} then {
		utimer $dvs_fserve(maxidle) "dvs_fserve:func:idleman $idx kill"
	} else {
		utimer [expr $dvs_fserve(maxidle) - 30] "dvs_fserve:func:idleman $idx warn"
	}

	putdcc $idx "Welcome, $nick."
	putdcc $idx "Fserve script by DVS01 v[dvs_fserve:func:version version formatted] \[[dvs_fserve:func:version ts date]\]"
	putdcc $idx "Type \"help\" for a listing of all the commands."
	dvs_fserve:func:motd $idx
	dvs_fserve:func:uinfo say $idx "*** $nick has connected to the Fserve."
	dvs_fserve:log:chatter "*** <$idx> $nick has connected to the Fserve."
	control $idx "dvs_fserve:control:fserve [split $nick] [split $uhost]"
	return 0
}

proc dvs_fserve:control:fserve {nick uhost idx text} {
	global dvs_fserve_slots dvs_fserve dvs_fserve_path dvs_fserve_stats

	dvs_fserve:func:idleman $idx clean
	if {[dvs_fserve:func:floodctrl fserve $idx] && ![dvs_fserve:func:slots get $idx janitor]} then {
		dvs_fserve:func:ukill $idx 0 0 "Flood."
		return 1
	}
	dvs_fserve:func:userlist set [dvs_func:maskhost $nick!$uhost *.*u.*h] ts [unixtime]
	dvs_fserve:func:slots set $idx idle [unixtime]
	if {$dvs_fserve(maxidle) < 31} then {
		utimer $dvs_fserve(maxidle) "dvs_fserve:func:idleman $idx kill"
	} else {
		utimer [expr $dvs_fserve(maxidle) - ([dvs_fserve:func:slots get $idx janitor] ? 0 : 30)] "dvs_fserve:func:idleman $idx warn"
	}
	
	if {$dvs_fserve_stats(lock) && $text != ""} then {
		putdcc $idx "j[u][b]IRC[b]off[u] Fserve is currently locked."
		return 0
	} elseif {$text == ""} then {
		dvs_fserve:func:ukill $idx 0 1
		return 1
	}
	set string $text
	set text [string trimleft $text]
	set command [string tolower [dvs_func:sindex $text 0]]
	set text [dvs_func:srange $text 1 end]
	if {$command == "" && $string != ""} then {
		set command .
	}

	switch -- $command\
	"" {
		# Bah. This seems like an eggdrop bug or something. At this point, all our idx's are considered invalid for some reason.
		dvs_fserve:func:ukill $idx 0 1
		return 1
	} cd {
		dvs_fserve:func:fs-cd $idx $text
	} credits {
		dvs_fserve:func:fs-credits $idx
	} dir {
		dvs_fserve:func:fs-dir $idx
	} exit {
		dvs_fserve:func:ukill $idx 0 0 "Goodbye."
		dvs_fserve:log:cmd "<${idx}> (${nick}) $command $text"
		dvs_fserve:log:input "<${idx}> (${nick}!${uhost}) $command $text"
		return 1
	} find {
		dvs_fserve:func:fs-find $idx $text
	} get {
		dvs_fserve:func:fs-get $idx $text
	} help {
		if {[llength [split $text]] > 1 || $text == ""} then {
			putdcc $idx [dvs_fserve:func:help fs all]
		} else {
			putdcc $idx [dvs_fserve:func:help fs $text]
		}
	} login {
		dvs_fserve:func:fs-login $idx $text
		dvs_fserve:log:cmd "<${idx}> (${nick}) $command <PASS>"
		return 0
	} ls {
		dvs_fserve:func:fs-ls $idx $text
	} pwd {
		set pwd [dvs_fserve:func:dir relative [dvs_fserve:func:slots get $idx pwd]]
		putdcc $idx "### \[$pwd\]"
	} say {
		dvs_fserve:func:fs-say $idx $text
	} stats {
		dvs_fserve:func:fs-stats $idx
	} who {
		dvs_fserve:func:fs-who $idx
	} cp {
		set src [dvs_func:sindex $text 0]
		set dest [dvs_func:srange $text 1 end]
		dvs_fserve:func:fs-cp $idx $src $dest
	} mv {
		set src [dvs_func:sindex $text 0]
		set dest [dvs_func:srange $text 1 end]
		dvs_fserve:func:fs-mv $idx $src $dest
	} mkdir {
		dvs_fserve:func:fs-mkdir $idx $text
	} rm {
		dvs_fserve:func:fs-rm $idx $text
	} rmdir {
		dvs_fserve:func:fs-rmdir $idx $text
	} default {
		putdcc $idx "Invalid command."
		dvs_fserve:log:input "<${idx}> (${nick}!${uhost}) $command $text"
		return 0
	}

	dvs_fserve:log:cmd "<${idx}> (${nick}) $command $text"
	dvs_fserve:log:input "<${idx}> (${nick}!${uhost}) $command $text"
	return 0
}

### USER KILLER ###
proc dvs_fserve:func:ukill {idx kill wait {message ""}} {
	global dvs_fserve_slots
	
	set hostmask [dvs_func:maskhost n![dvs_fserve:func:slots get $idx host] *.*u.*h]
	set nick [dvs_fserve:func:slots get $idx nick]
	dvs_fserve:func:userlist set $hostmask bcredits [dvs_fserve:func:slots get $idx bcredits]
	dvs_fserve:func:userlist set $hostmask fcredits [dvs_fserve:func:slots get $idx fcredits]
	unset dvs_fserve_slots($idx)
	if {$message != ""} then {
		putdcc $idx $message
	}
	if {$kill && [valididx $idx]} then {
		killdcc $idx
	}
	dvs_fserve:func:idleman $idx clean
	dvs_fserve:log:chatter "*** <$idx> $nick has disconnected from the Fserve."
	if {$wait} then {
		utimer $wait "dvs_fserve:func:uinfo say 0 \"*** $nick has disconnected from the Fserve.\""
	} else {
		dvs_fserve:func:uinfo say $idx "*** $nick has disconnected from the Fserve."
	}
}

### USER HANDLING ###
proc dvs_fserve:func:uinfo {command args} {
	switch -- $command\
	who {
		global dvs_fserve_slots
		set idxlist [array names dvs_fserve_slots]
		set pend [lsearch $idxlist pending]
		return [lreplace $idxlist $pend $pend]
	} say {
		set idxlist [dvs_fserve:func:uinfo who]
		set exclude [lsearch $idxlist [lindex $args 0]]
		foreach idx [lreplace $idxlist $exclude $exclude] {
			if {[valididx $idx]} then {
				putdcc $idx [lindex $args 1]
			}
		}
	} default {
		return -1
	}
}

### PENDING TRANSFER TIMEOUT PATROL ###
proc dvs_fserve:func:pendcheck {} {
	if {![string match *dvs?fserve?func?pendcheck* [string tolower [utimers]]]} then {
		utimer 15 "dvs_fserve:func:pendcheck"
	}
	foreach idx [dcclist] {
		if {([lindex $idx 3] == "GET_PENDING" || [lindex $idx 3] == "SEND_PENDING") && [unixtime] - [lrange $idx end end] >= 30} then {
			killdcc [lindex $idx 0]
		}
	}
	return
}

### RECURSIVE FILE FINDER ###
proc dvs_func:ffind {path filename {jan 1}} {
	global dvs_fserve_ffind dvs_fserve_ffind_cnt
	set dvs_fserve_ffind_cnt 0
	set dvs_fserve_ffind ""
	dvs_func:ff $path $filename 1 $jan
	set result $dvs_fserve_ffind
	unset dvs_fserve_ffind
	unset dvs_fserve_ffind_cnt
	return $result
}
	
proc dvs_func:ff {path filename level {jan 0}} {
	global dvs_fserve dvs_fserve_ffind dvs_fserve_ffind_cnt
	
	foreach entry [glob -nocomplain -- [dvs_func:pathdeglob $path]/*] {
		if {[file isfile $entry] && [string match [string tolower $filename] [string tolower [file tail $entry]]]} then {
			incr dvs_fserve_ffind_cnt
			if {$dvs_fserve_ffind_cnt > $dvs_fserve(maxmatches)} then {
				return
			}
			set append 1
			foreach jdir $dvs_fserve(jdirs) {
				set dir [file dirname $entry]
				if {!$jan && [dvs_fserve:func:dir isin $dir $jdir] != 0} then {
					set append 0
				}
			}
			if {$append} then {
				lappend dvs_fserve_ffind $entry
			}
		} elseif {[file isdirectory $entry]} then {
			dvs_func:ff $entry $filename [expr $level + 1] $jan
		}
	}
}

### IDLE TIMEOUT CONTROL ###
proc dvs_fserve:func:idleman {idx {action "warn"}} {
	global dvs_fserve_slots
	
	switch $action\
	warn {
		dvs_fserve:func:idleman $idx clean
		if {[valididx $idx]} then {
			putdcc $idx "Closing idle connection in 30 seconds..."
		}
		utimer 30 "dvs_fserve:func:idleman $idx kill"
	} kill {
		dvs_fserve:func:idleman $idx clean
		if {[valididx $idx]} then {
			dvs_fserve:func:ukill $idx 1 0 "Idle timeout."
		}
	} clean {
		foreach utimer [utimers] {
			set entry [lindex $utimer 1]
			if {[lindex $entry 0] == "dvs_fserve:func:idleman" && [lindex $entry 1] == $idx} then {
				killutimer [lrange $utimer end end]
			}
		}
	} default {
		return "Invalid option. Valid options: warn, kill, clean."
	}
}

### PLURALIZATION ###
proc dvs_func:plural {num string1 string2} {
	if {$num == 1} then {
		return $string1
	} else {
		return $string2
	}
}

### PATH GLOB CHAR ESCAPER ### - original idea (used for list->string in bseen) by Bass
proc dvs_func:pathdeglob {text} {
	regsub -all -- \\* $text \\* text
	regsub -all -- \\, $text \\, text
	regsub -all -- \\? $text \\? text
	regsub -all -- \\- $text \\- text
	regsub -all -- \\\[ $text \\\[ text
	regsub -all -- \\\] $text \\\] text
	regsub -all -- \\\{ $text \\\{ text
	regsub -all -- \\\} $text \\\} text
	return $text
}

### UPLOAD HANDLING ###
proc dvs_fserve:func:uluser {} {
	global default-flags

	if {![validuser jsrvuser] || [getuser jsrvuser COMMENT] != "j[u][b]IRC[b]off[u] Fserve [dvs_fserve:func:version version formatted]"} then {
		#putlog "Is user valid? [validuser jsrvuser]"
		if {[validuser jsrvuser]} {
			#putlog "Comment is: [getuser jsrvuser COMMENT]"}
		# Clear em just in case
		deluser jsrvuser
		deluser jsrvtemp
		
		# Add user
		adduser jsrvuser ""
		# Unshare them
		chattr jsrvuser u
		# Change their handle
		chnick jsrvuser jsrvtemp
		# Add new user with srv nick
		adduser jsrvuser ""
		# Delete it, which would make other bots delete it
		deluser jsrvuser
		# Change back from temp handle
		chnick jsrvtemp jsrvuser
		# Unset any default flags except for +u
		chattr jsrvuser -[string map {u ""} [chattr jsrvuser]]
		# Set needed fserve flags
		chattr jsrvuser +x
		setuser jsrvuser PASS [clock clicks]
		setuser jsrvuser COMMENT "j[u][b]IRC[b]off[u] Fserve [dvs_fserve:func:version version formatted]"
	}
}

bind raw -|- PRIVMSG dvs_fserve:raw:incoming
proc dvs_fserve:raw:incoming {from keyword text} {
	global dvs_fserve max-dcc dvs_fserve

	set hand [finduser $from]
	set nick [dvs_func:sindex $from 0 !]
	if {[dvs_func:srange $text 1 2] != ":\001DCC SEND" || !$dvs_fserve(allowuploads)} then {
		return 0
	}
	dvs_fserve:func:uluser
	set filename [dvs_func:sindex $text 3]
	set size [string trimright [dvs_func:sindex $text 6] \001]
	if {![dvs_func:validnum $size]} then {
		set size 0
	}

	set uploads [expr [lindex [dvs_fserve:func:transfers incoming $nick] 0] + [lindex [dvs_fserve:func:transfers pendin $nick] 0]]
	set downloads [expr [lindex [dvs_fserve:func:transfers outgoing $nick] 0] + [lindex [dvs_fserve:func:transfers pendout $nick] 0]]

	if {${max-dcc} <= [dccused]} then {
		dvs_fserve:log:incoming "Rejecting file from (${from}): ([dvs_func:nformat [format %.3f [expr double($size) / 1024.0]]]k) $filename .. Too many dcc slots in use."
		return 0
	} elseif {$dvs_fserve(maxgets) <= [lindex [dvs_fserve:func:transfers incoming] 0] + [lindex [dvs_fserve:func:transfers pendin] 0]} then {
		dvs_fserve:log:incoming "Rejecting file from (${from}): ([dvs_func:nformat [format %.3f [expr double($size) / 1024.0]]]k) $filename .. Too many incoming transfers."
		return 0
	} elseif {$uploads + $downloads >= $dvs_fserve(maxtrans) && ![matchattr $hand $dvs_fserve(janflags)]} then {
		dvs_fserve:log:incoming "Rejecting file from (${from}): ([dvs_func:nformat [format %.3f [expr double($size) / 1024.0]]]k) $filename .. User has too many transfers."
		return 0
	} elseif {$uploads >= $dvs_fserve(maxuploads) && ![matchattr $hand $dvs_fserve(janflags)]} then {
		dvs_fserve:log:incoming "Rejecting file from (${from}): ([dvs_func:nformat [format %.3f [expr double($size) / 1024.0]]]k) $filename .. Too many incoming files from the user."
		return 0
	}
	
	dvs_fserve:log:incoming "Getting file from (${from}): ([dvs_func:nformat [format %.3f [expr double($size) / 1024.0]]]k) $filename"

	if {[matchattr $hand x]} then {
		return 0
	}
	# Add their host for a sec to allow the bot to accept the incoming file
	setuser jsrvuser HOSTS $from
	utimer 1 {catch {setuser jsrvuser HOSTS}}
	return 0
}

# dvs_fserve:log:
#  cmd input chatter outgoing incoming

#  (22) RCVD   (stackable)
#       bind rcvd <flags> <mask> <proc>
#       proc-name <handle> <nick> <path/to/file>
#
#       triggered after a user uploads a file successfully; mask is matched
#       against the user's handle; nick is the nickname on IRC that the file
#       transfer originated from; the path is where the file ended up,
#       relative to the dcc directory (usually this is your incoming dir)
#       (THIS IS ONLY AVALIABLE WHEN THE transfer.so MODULE IS LOADED)

# credits = credits + (double(y)/x * filesize)

# credits handling
# everything relies on the userlist

bind rcvd - * dvs_fserve:rcvd:addcredits 
proc dvs_fserve:rcvd:addcredits {hand nick file} {
	global dvs_fserve dvs_fserve_stats env
	
	set size [file size $file]
	
	incr dvs_fserve_stats(frecieved)
	set dvs_fserve_stats(krecieved) [expr $dvs_fserve_stats(krecieved) + double($size) / 1024]
	
	foreach entry $dvs_fserve(filefilter) {
		set mask [lindex $entry 0]
		set path [lindex $entry 1]
		set move [lindex $entry 2]
		if {![string match $mask [file tail $file]] || [file exists $path/[file tail $file]]} then {
			continue
		}
		set found 1
		set path [subst $path]
		if {![file exists $path]} then {
			catch {
				file mkdir $path
			}
		}
		if {$move} then {
			catch {
				file rename -- $file $path/[file tail $file]
			}
		} else {
			catch {
				file copy -- $file $path/[file tail $file]
			}
		}
	}
}

#	set hostmask [dvs_func:maskhost $nick!$uhost *.*u.*h]
#	if {![dvs_fserve:func:userlist exists $hostmask]} then {
#		dvs_fserve:func:userlist set $hostmask all "[unixtime] $dvs_fserve(startbcredits) $dvs_fserve(startfcredits)"
#	}
#	dvs_fserve:func:slots set $idx all "$nick $uhost [dvs_fserve:func:userlist get $hostmask bcredits] [dvs_fserve:func:userlist get $hostmask fcredits] $dvs_fserve_path [unixtime] 0"
	

#	set bcredits [dvs_fserve:func:slots get $idx bcredits]
#	set fcredits [dvs_fserve:func:slots get $idx fcredits]
#	set a [lindex [split $dvs_fserve(bratio)] : 0]
#	set b [lindex [split $dvs_fserve(bratio)] : 1]
#	set x [lindex [split $dvs_fserve(fratio)] : 0]
#	set y [lindex [split $dvs_fserve(fratio)] : 1]
#	
#	switch -- $dvs_fserve(ratiotype)\
#	1 {
#		incr bcredits $size
#		dvs_fserve:func:slots set $idx bcredits $bcredits
#	} 2 {
#		incr fcredits -1
#		dvs_fserve:func:slots set $idx fcredits $fcredits
#	} 3 {
#		incr bcredits -$size
#		incr fcredits -1
#		dvs_fserve:func:slots set $idx bcredits $bcredits
#		dvs_fserve:func:slots set $idx fcredits $fcredits
#	}
#}
	
### LONGIP -> DOTTED QUAD ADDRESS CONVERTER ### - Thanks MrGrim
proc dvs_func:longip-2-quad {longip} {
	set ip1 [expr ($longip >> 24) & 255]
	set ip2 [expr ($longip >> 16) & 255]
	set ip3 [expr ($longip >> 8) & 255]
	set ip4 [expr $longip & 255]
	return ${ip1}.${ip2}.${ip3}.${ip4}
}

dvs_fserve:func:startup
set dvs_fserve_loaded 1

putlog "j[u][b]IRC[b]off[u] Fserve script ([info script]) by DVS01 v[dvs_fserve:func:version version formatted] \[[dvs_fserve:func:version ts date]\]"